////////////////////////////////////////////////////////////////////////
////                          OS_Define.c                           ////
////                                                                ////
////  Define utilis par l'OS										////
////                 18F242 quartz 20 MHz ou 10Mhz *4 (PLL) = 40Mhz ////
////  Auteur: 	LG					     							////
////  Date:	 15 novembre 2003                                     	////
////                                                                ////
////////////////////////////////////////////////////////////////////////
////        (C) Copyright 2003 - LG				             		////
////								     							////
////////////////////////////////////////////////////////////////////////
// #define DEBUG 1

#define uchar unsigned char
#define uint unsigned int
#define ulong unsigned long

#define CLIGNOTEMENT_2SECONDES 5
// Define pour la commande des capteurs sharp
#define NOMBRE_CAPTEUR_SHARP	4 // il y a 4 capteurs sharp
#define CAPTEUR_AVANT	0
#define CAPTEUR_DROIT	1
#define CAPTEUR_ARRIERE	2
#define CAPTEUR_GAUCHE	3
// dfinition des distances, utilis pour la mesure sur les capteurs SHARP 
#define DISTANCE_10CM_AVANT	0xF2	// le mur est  10cm AE
#define DISTANCE_20CM_AVANT	0x86	// le mur est  20cm
#define DISTANCE_22CM_AVANT	0x75	// le mur est  20cm  
#define DISTANCE_30CM_AVANT	0x5A	// le mur est  30cm
#define DISTANCE_50CM_AVANT	0x36	// le mur est  50cm
#define DISTANCE_70CM_AVANT	0x2B	// le mur est  70cm

#define DISTANCE_10CM_DROIT	0xF2	// le mur est  10cm
#define DISTANCE_15CM_DROIT	0xA0	// le mur est  15cm
#define DISTANCE_20CM_DROIT	0x8C	// le mur est  20cm  6B 72
#define DISTANCE_30CM_DROIT	0x5B	// le mur est  30cm  5A
#define DISTANCE_50CM_DROIT	0x3C	// le mur est  50cm	36
#define DISTANCE_70CM_DROIT	0x2B	// le mur est  70cm

#define DISTANCE_10CM_ARRIERE	0xF2	// le mur est  10cm AE
#define DISTANCE_20CM_ARRIERE	0x83	// le mur est  20cm 5E
#define DISTANCE_30CM_ARRIERE	0x5A	// le mur est  30cm 5A
#define DISTANCE_50CM_ARRIERE	0x3A	// le mur est  50cm 36
#define DISTANCE_70CM_ARRIERE	0x2B	// le mur est  70cm

#define DISTANCE_10CM_GAUCHE	0xF2	// le mur est  10cm AE
#define DISTANCE_20CM_GAUCHE	0x93	// le mur est  20cm 6C 72 83
#define DISTANCE_30CM_GAUCHE	0x5A	// le mur est  30cm
#define DISTANCE_50CM_GAUCHE	0x36	// le mur est  50cm
#define DISTANCE_70CM_GAUCHE	0x2B	// le mur est  70cm

// dfinition des masques de codage de la position des mur:
#define MUR_A_0_CASE_AVANT 0x00		// 00 MUR  20cm
#define MUR_A_1_CASE_AVANT 0x40		// 01 MUR  60cm
#define MUR_AU_DELA_2_CASE_AVANT 0x80	// 10 MUR  +de 80cm
							// 11 RFU
#define MUR_A_0_CASE_DROIT	0x00
#define MUR_A_1_CASE_DROIT	0x10
#define MUR_AU_DELA_2_CASE_DROIT	0x20	
							
#define MUR_A_0_CASE_ARRIERE	0x00
#define MUR_A_1_CASE_ARRIERE	0x04
#define MUR_AU_DELA_2_CASE_ARRIERE	0x08

#define MUR_A_0_CASE_GAUCHE		0x00
#define MUR_A_1_CASE_GAUCHE		0x01
#define MUR_AU_DELA_2_CASE_GAUCHE	0x02
							
// define utilis pour le codage du tableau qui stock les valeurs du poids des cases							
// le format du tableau dans la feuille excel est le suivant:
// NumroCase    |   Ligne      |    Colonne     |   Noeud      |    Orientation
#define NUM	0	// correspond  la colonne 0 du tableau, numro de la cellule
#define LIGNE	1	// numro de la ligne dans le labyrinthe
#define COLONNE		2	// numro de la colone
#define NOEUD	3
#define ORIENTATION 4
							
						
// Define pour la commande des moteurs.
#define MOTEUR_DROIT_ARRET 0	// valeur pour arreter le moteur
#define MOTEUR_DROIT_AVANT 1	// valeur pour avancer sur le moteur droit
#define MOTEUR_DROIT_ARRIERE 2	// Valeur pour reculer sur le moteur gauche
#define MOTEUR_GAUCHE_ARRET 0
#define MOTEUR_GAUCHE_AVANT 1
#define MOTEUR_GAUCHE_ARRIERE 2

#define TIMING_20MS	25000	//temps pour avoir 20ms sur le TIMER 0
#define TIMING_18MS 22500	// temps pour avoir 18ms sur le TIMER 0
#define TIMING_1MS 1250	// temps pour avoir 1ms sur le TIMER 0
#define TIMING_2MS	2500 // temps pour avoir 2ms sur le TIMER 0

//calcul des distance.
//#define DISTANCE_AVANT_40CM			360000
//#define DISTANCE_ARRIERE_40CM		-400000
#define DISTANCE_AVANT_40CM			110
#define DISTANCE_AVANT_30CM			80
#define DISTANCE_ARRIERE_40CM		-400000
//#define DISTANCE_ARRIERE_40CM		110
#define DISTANCE_ARRIERE_20CM		-200000

//#define ROTATION_DROITE_90			-150000
//#define ROTATION_GAUCHE_90			130000

#define ROTATION_DROITE_90			-100000  //-11000
#define ROTATION_DROITE_100			-120000
#define ROTATION_GAUCHE_90			120000

