////////////////////////////////////////////////////////////////////////
////                          PicoBot.c                             ////
////                                                                ////
////  Programme principal de commande du robot						////
////                 18F242 quartz 20 MHz ou 10Mhz *4 (PLL) = 40Mhz ////
////  Auteur: 	LG					     							////
////  Date:	 09 novembre 2003                                     	////
////                                                                ////
////////////////////////////////////////////////////////////////////////
////        (C) Copyright 2003 - LG				             		////
////								     							////
////////////////////////////////////////////////////////////////////////
// code final
//#include "PicoBot.h"	// appel d'inclusion globale
#include "Picobot.h"
#include "OS_GlobalRAM.h"

#pragma romdata CONFIG
_CONFIG_DECL (
_CONFIG1H_DEFAULT & _OSC_HS_1H , 		
_CONFIG2L_DEFAULT & _PWRT_ON_2L , 
_CONFIG2H_DEFAULT & _WDT_OFF_2H,		// pas de watchdog
_CONFIG3H_DEFAULT,
_CONFIG4L_DEFAULT & _STVR_ON_4L & _LVP_OFF_4L & _DEBUG_OFF_4L , //Stack overflow reset, debug off, LVP ICSP prog off
_CONFIG5L_DEFAULT & _CP0_OFF_5L & _CP1_OFF_5L, // pas de protection de code
_CONFIG5H_DEFAULT & _CPB_OFF_5H & _CPD_OFF_5H, 		// pas de protection EEPROM et boot code
_CONFIG6L_DEFAULT & _WRT0_OFF_6L & _WRT1_OFF_6L, // 
_CONFIG6H_DEFAULT & _WPC_OFF_6H & _WPB_OFF_6H & _WPD_OFF_6H,
_CONFIG7L_DEFAULT & _EBTR0_OFF_7L & _EBTR1_OFF_7L,
_CONFIG7H_DEFAULT & _EBTRB_OFF_7H
); 
#pragma romdata

/********************************************************
Fonction: main
Utilisation: Fonction principal du programme appel au boot du PIC
Date: 09/11/2003
Auteur: LG
********************************************************/

void main (void)
{
// dclaration de variables locales
// dbut du corps de la fonction 

// configuration du processeur

	OS_ConfigurationProcesseur();
	OS_InitLcd();
	OS_IntialisationVariableGlobale();
	OS_Lcd_Clear();
//	OS_Lcd_ReturnHome();
	

#ifndef DEBUG
//	OS_ClignotementLed400ms(5);	// clignotement pendant 2s
//	OS_Lcd_Char(0x4C);	// L
//	OS_Lcd_Char(0x47);	// G
	OS_Lcd_Char('P');	// espace
	OS_Lcd_Char('i');	// espace
	OS_Lcd_Char('c');	// espace
	OS_Lcd_Char('o');	// espace	
	OS_Lcd_Char('b');	// espace
	OS_Lcd_Char('o');	// espace	
	OS_Lcd_Char('t');	// espace	
	OS_Lcd_Char(0x20);	// espace
	OS_Lcd_Line(2);
	OS_Lcd_Char(0x32);	// 2
	OS_Lcd_Char(0x30);	// 0
	OS_Lcd_Char(0x30);	// 0
	OS_Lcd_Char(0x34);	// 4
	OS_ClignotementLed400ms(2);	// clignotement pendant 4s
//	while(1);
#endif	
	// chargement du registre de TR0 par la valeur 25000, ce qui correspond  un temps de cycle de 20ms. calibration pour les servos.
	WriteTimer0( 0xFFFF - TIMING_20MS);
	GUI_Timing20ms = TIMING_20MS;	// indication pour la premiere interruption
	GUC_MoteurDroit = MOTEUR_DROIT_ARRET;
	GUC_MoteurGauche = MOTEUR_GAUCHE_ARRET;
	PORTCbits.RC1 = 0; // arrt servos 1
	PORTCbits.RC2 = 0; // arrt servos 2
	OS_Lcd_Clear();
	// appel de la fonction de conversion  AN et conversion en mesure labyrinthe
/*	while (1)
	{
	OS_ConversionAN();
	// affichage du rsultat
	OS_Lcd_ReturnHome();
	OS_Lcd_Clear();
	OS_Lcd_Hexa(GUC_Poids_Cellule);
	OS_ClignotementLed400ms(5);	// clignotement pendant 4s
	}
	
*/	
	// ----------------------------------------------
	// recherche de la position dans le labyrinthe.
//	LAB_ReperagePosition();
	// recherche de la sortie.
	// Initialisation des variables.

//	LAB_RechercheSortie();	// lancement de la sortie!
	//------------------------------------------------
	
// dbut de la boucle principale	
//	OS_EnableAllInterrupt();  // activation des interruptions globales 

	OS_DisableAllInterrupt();
#ifndef DEBUG
	while ( OS_EtatBouton() == 1);  // attente d'appuyer sur le bouton
#endif
/*	while(1)
	{
	OS_ConversionAN();
	OS_Lcd_Clear();
	OS_Lcd_Hexa(GUC_TAB_Distance[CAPTEUR_GAUCHE]);
	OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
	}
*/
//	OS_Avancer(DISTANCE_AVANT_30CM);
//	OS_EnableAllInterrupt();
//	OS_Avancer(DISTANCE_AVANT_40CM);
//	OS_ClignotementLed400ms(3);	// clignotement pendant 0.4s
//	OS_MesureAccelerationStatique();
//	OS_TournerDroite(ROTATION_DROITE_90);	//de 90
//	OS_TournerGauche(ROTATION_GAUCHE_90);	//de 90
//	OS_Avancer(DISTANCE_AVANT_40CM);
//	OS_Avancer(DISTANCE_AVANT_40CM);
//	while (1);
/*	OS_Avancer(DISTANCE_AVANT_40CM);
	OS_ClignotementLed400ms(3);	// clignotement pendant 0.4s
	OS_MesureAccelerationStatique();
	OS_TournerGauche(ROTATION_GAUCHE_90);	//de 90
	OS_ClignotementLed400ms(3);	// clignotement pendant 0.4s
	OS_Avancer(DISTANCE_AVANT_40CM);
	OS_ClignotementLed400ms(3);	// clignotement pendant 0.4s
	OS_MesureAccelerationStatique();
	OS_TournerDroite(ROTATION_DROITE_90);	//de 90
	OS_ClignotementLed400ms(3);	// clignotement pendant 0.4s
	while (1);
*/
//	while(1)	 {
		// ordre pour les moteurs
//		OS_TestMoteur();
	// test de l'acclrometre.
//	OS_TestAdxL202();
	// test de la fonction de recherche de sortie
	// Initialisation des variables
// dbut du corps de la fonction 

// partie pour la recherche de position dans le labyrinthe.

//	OS_Avancer(DISTANCE_AVANT_40CM);	
//	OS_MoteurArret();	// on arrete le moteur.
//	OS_ClignotementLed400ms(1);	// clignotement pendant 2s
//	OS_ClignotementLed400ms(2);	// clignotement pendant 2s
	while (1)
	{
	OS_DisableAllInterrupt();
	OS_IntialisationVariableGlobale();
	OS_EnableAllInterrupt();  // activation des interruptions globales 
	//LAB_ReperagePosition();
	while(	LAB_ReperagePosition() ==0 )
	{	OS_DisableAllInterrupt();
		OS_IntialisationVariableGlobale();	// on boucle tant qu'on ne retourne pas 1 donc OK!
		OS_EnableAllInterrupt();  // activation des interruptions globales 
	}

	OS_Lcd_Clear();
	OS_Lcd_Char('X');
	OS_Lcd_Char(0x30+GUC_PositionX);	// 
	OS_Lcd_Char(' ');
	OS_Lcd_Char('Y');
	OS_Lcd_Char(0x30+GUC_PositionY);	// 
	OS_Lcd_Char(' ');
	OS_Lcd_Char('o');
	OS_Lcd_Char(0x30+GUC_Orientation);	// 
	OS_Lcd_Line(2);
	OS_Lcd_Char(' ');
	OS_Lcd_Char('P');
	OS_Lcd_Hexa(GUC_Poids_Cellule); 
	OS_ClignotementLed400ms(1);	// clignotement pendant 2s
// Partie pour la recherche de la sortie.
	GSL_DistanceX =0;
	GSL_VitessePrecedenteX =0;
	GSL_VitesseX =0;
	GSL_Acceleration = 0;
	GSL_AccelerationStatiqueX=0;
	GSL_AccelerationStatiqueY=0;
//	GUC_Poids_Cellule=21;
//	GUC_PositionX=2;
//	GUC_PositionY=6;
//	GUC_Orientation = 1;
	LAB_RechercheSortie();
//	}
	OS_Avancer(DISTANCE_AVANT_40CM);				// avancer de 40cm
	OS_Lcd_Clear();
	OS_Lcd_Char('F');	// 
	OS_Lcd_Char('i');	// 
	OS_Lcd_Char('n');	// 
	OS_ClignotementLed400ms(4);	// clignotement pendant 2s
	}
//	while (1)	// un programme embarqu boucle toujours!
//		OS_ClignotementLed400ms(5);	// clignotement pendant 2s
}

void OS_ConfigurationProcesseur(void)
{
// dclarations de variables locales

// dbut du corps de la fonction	
	TRISA = 0xFF; // port A en entree
	TRISB = 0xC0;	// port B : RB7, RB6 en entre; RB5 -> RB0 en sortie;
	TRISC = 0x00; // port C en sortie

// configuration du PORT A
	// Convertisseur analogique/numerique desactives
	OpenADC(ADC_FOSC_2 & ADC_0ANA_0REF & ADC_RIGHT_JUST, ADC_INT_OFF);
// Configuration du PORT B	
	
// Configuration du PORT C

// Configuration du Timer 1 => Timer systme, temps de cycle 20ms base des servos
	OpenTimer0(TIMER_INT_ON & T0_16BIT & T0_SOURCE_INT & T0_PS_1_4); // Timer 0 Interruption on, mode 16 bits, prescaler /4
	
//	OpenTimer1(T1_16BIT_RW & T1_SOURCE_INT & T1_PS_1_1 & T1_SYNC_EXT_OFF); // Timer 1 Interruption off, mode 16 bits, postscaler /1
	OpenTimer3(T3_16BIT_RW & T3_SOURCE_INT & T3_PS_1_1 & T3_SYNC_EXT_OFF & T3_OSC1EN_OFF); // Timer 1 Interruption off, mode 16 bits, postscaler /1
//	T1CON = 0x81; //valeur programm par dfaut en lieu et place du OpenTimer1
		
}


/********************************************************
Fonction: atHighVector
Utilisation: gestion des interruptions de niveau Haut
Date: 17/11/2003
Auteur: LG
********************************************************/
#pragma code highVector=0x08
void atHighVector(void)
{
_asm GOTO OS_InterruptHigh  _endasm
}
#pragma code // retour  la zone de code

/********************************************************
Fonction: atLowVector
Utilisation: Gestion des interruptions de faible niveau
Date: 05/12/2003
Auteur: LG
********************************************************/
#pragma code lowVector=0x18
void atLowVector(void)
{
_asm GOTO OS_InterruptLow  _endasm
}
#pragma code // retour  la zone de code



/********************************************************
Fonction: OS_EnableAllinterrupt
Utilisation: utilis pour afficher le rsultat des capteurs
Date: 30/11/2003
Auteur: LG
********************************************************/
void OS_EnableAllInterrupt(void)
{
	// activation du niveau d'interruption!
	INTCON2bits.TMR0IP =1; // interruption TIMER 0 priorit haute.
	PIE1bits.TMR1IE =0;	// dsactivation des interruptions par overflow sur le Timer1
	PIR1bits.TMR1IF=0;	// mise  0 du flag
	PIE2bits.TMR3IE=0;	// pas d'interruption timer 3
	PIR2bits.TMR3IF=0;	// remise  0 du flag.
	INTCONbits.RBIE =0; // interruption sur portB non  autoris.
	INTCONbits.RBIF =0;	// mise  0 du flag
	INTCON2bits.RBIP = 1; // Interruption sur le port B priorit haute.
	INTCONbits.PEIE = 1; // Activation des interruptions de niveau bas.
	INTCONbits.GIE = 1; // Activation des interuptions de niveau haut.
	RCONbits.IPEN = 0; //dsactivation du niveau des interruptions

}
/********************************************************
Fonction: OS_DisableAllinterrupt
Utilisation: deactivation des capteurs
Date: 05/12/2003
Auteur: LG
********************************************************/
void OS_DisableAllInterrupt(void)
{
	// activation du niveau d'interruption!
	INTCONbits.GIE = 0; // deactivation des interuptions de niveau haut.
	INTCONbits.PEIE = 0; // deactivation des interruptions de niveau bas.
}


/********************************************************
Fonction: OS_CapteurDebug
Utilisation: utilis pour afficher le rsultat des capteurs
Date: 30/11/2003
Auteur: LG
********************************************************/
void OS_CapteurDebug(void)
{
// dclaration de variables locales

// dbut du corps de la fonction 
	OS_ConversionAN();		// conversion des 4 valeurs analogiques issues des capteurs sharp.
	OS_Lcd_Clear();
	OS_Lcd_ReturnHome();	
	OS_Lcd_Char(0x56);	// V
	OS_Lcd_Char(0x31);	// 1
	OS_Lcd_Char(0x3A);	// :
	OS_Lcd_Hexa(GUC_TAB_Distance[CAPTEUR_AVANT]);
	OS_Lcd_Clear();
	OS_Lcd_ReturnHome();	
	OS_Lcd_Char(0x56);	// V
	OS_Lcd_Char(0x32);	// 2
	OS_Lcd_Char(0x3A);	// :
	OS_Lcd_Hexa(GUC_TAB_Distance[CAPTEUR_DROIT]);
	OS_Lcd_Clear();
	OS_Lcd_ReturnHome();	
	OS_Lcd_Char(0x56);	// V
	OS_Lcd_Char(0x33);	// 3
	OS_Lcd_Char(0x3A);	// :
	OS_Lcd_Hexa(GUC_TAB_Distance[CAPTEUR_ARRIERE]);
	OS_Lcd_Clear();
	OS_Lcd_ReturnHome();	
	OS_Lcd_Char(0x56);	// V
	OS_Lcd_Char(0x34);	// 4
	OS_Lcd_Char(0x3A);	// :
	OS_Lcd_Hexa(GUC_TAB_Distance[CAPTEUR_GAUCHE]);
}	// OS_CapteurDebug
/********************************************************
Fonction: OS_TestMoteur
Utilisation:Fonction de test pour les servos moteurs. 
Date: 05/12/2003
Auteur: LG
********************************************************/
void OS_TestMoteur(void)
{
// dclaration de variables locales

// dbut du corps de la fonction 

		OS_MoteurAvancer();
		OS_ClignotementLed400ms(2);	// clignotement pendant 4s
// 		OS_ClignotementLed400ms(5);	// clignotement pendant 4s
//		OS_ClignotementLed400ms(5);	// clignotement pendant 4s
		OS_MoteurGauche();
		OS_ClignotementLed400ms(2);	// clignotement pendant 4s
// 		OS_ClignotementLed400ms(5);	// clignotement pendant 4s
//		OS_ClignotementLed400ms(5);	// clignotement pendant 4s
		OS_MoteurArriere();
		OS_ClignotementLed400ms(5);	// clignotement pendant 4s
//		OS_ClignotementLed400ms(5);	// clignotement pendant 4s
//		OS_ClignotementLed400ms(5);	// clignotement pendant 4s
		OS_MoteurDroite();
		OS_ClignotementLed400ms(5);	// clignotement pendant 4s
// 		OS_ClignotementLed400ms(5);	// clignotement pendant 4s
//		OS_ClignotementLed400ms(5);	// clignotement pendant 4s
		
}		

void OS_IntialisationVariableGlobale(void)
{
	GUC_MoteurDroit = MOTEUR_DROIT_ARRET;
	GUC_MoteurGauche = MOTEUR_GAUCHE_ARRET;
	GUC_TAB_Distance[0]=0; // utilis dans le fonction de mesure de distance par rapport au bords
	GUC_TAB_Distance[1]=0; // utilis dans le fonction de mesure de distance par rapport au bords
	GUC_TAB_Distance[2]=0; // utilis dans le fonction de mesure de distance par rapport au bords
	GUC_TAB_Distance[3]=0; // utilis dans le fonction de mesure de distance par rapport au bords
// variable pour la commande de moteur
	GUI_Timing20ms=0;	// variable pour comptabilis le temps sur 20ms
	// uchar i;	// variable pour le rglage de l'asservissement.
// variable pour la mesure de l'acclration
	GUI_TempsT1X =0;	// temps pour le crneau X
	GUI_TempsT1Y =0;	// temps pour le crneau Y
	GUI_TempsTb=0;	// front descendant du crneaux X
	GUI_TempsTc=0; 	// front montant du crneaux Y
	GUI_TempsTd=0;	// front descendant du crneaux Y
	GUI_TempsT2=0; 	// variable pour le temps T2 de la priode de l'acclrometre
	GUC_EtatAccelerometre=0; // indique l'etat de l'accelerometre
	GSL_AccelerationX=0;	// valeur de l'acclration sur l'axe X
	GSL_AccelerationY=0;	// valeur de l'acclration sur l'axe Y
	GSL_Acceleration=0 ;
	GSL_AccelerationStatiqueX=0;
	GSL_AccelerationStatiqueY=0;

// variable pour le calcul des distances parcouru en X et en Y
	GSL_DistanceX=0 ;
	GSL_VitessePrecedenteX=0 ;
	GSL_VitesseX=0 ;
	GSL_DistanceY=0 ;
	GSL_VitessePrecedenteY=0 ;
	GSL_VitesseY =0;


// variable pour le labyrinthe
//uchar GUC_CelluleValeur;		// sauve le poids de la cellule en cours par rapport  la sortie
	GUC_Sortie=0;			// test pour la sortie
	GUC_Trouve=0;			// variable pour indiquer qu'on a trouv la prochaine cellule
	GUC_Ordre=0;			// variable pour la consigne de commande
	GUC_PositionX=0;		// variable pour la position dans le labyrinthe colonne du tableau
	GUC_PositionY=0;		// variable pour la position dans le labyrinthe ligne du tableau
	GUC_Orientation=0;		// mmorise l'orientation courante dans le labyrinthe
//uchar const GUC_TAB_TableauSortie[9][9];

	GUC_Capteur_Avant=0;	// indique l'tat du capteur avant 0 pas de mur  20cm, 1 mur  20cm
	GUC_Capteur_Arriere=0;	// indique l'tat du capteur avant 0 pas de mur  20cm, 1 mur  20cm
	GUC_Capteur_Droit=0;	// indique l'tat du capteur avant 0 pas de mur  20cm, 1 mur  20cm
	GUC_Capteur_Gauche=0;	// indique l'tat du capteur avant 0 pas de mur  20cm, 1 mur  20cm

// variable utili par la fonction de recherche de position dans le labyrinthe
GUC_Index=0;
GUC_Index2=0;
GUC_Index3=0;
GUC_Mesure1=0;				//premiere valeur mesure par les capteurs;
GUC_Mesure2=0;           	// deuxieme valeur mesure par les capteurs;
GUC_NbResultat=0;	       	// donne le nombre de rsultats trouvs.
GUC_NbResultat2=0;      	// donne le nombre de resultats trouvs suite au premier dplacement!
GUC_Avance=0;
GUC_Recule=0;
GUC_Droite=0;
GUC_Gauche=0;
GUC_Solution=0;         	//variable qui stocke le nombre de rsultat dans la comparaison des tableaux.
//GUC_Tableau1[11][5];
//GUC_Tableau2[11][5];
//GUC_Tableau3[11][5];
for(GUC_Index =0;GUC_Index<11;GUC_Index++)
	        {
	        	GUC_Tableau1[GUC_Index][COLONNE]=0;
				GUC_Tableau1[GUC_Index][LIGNE]=0;
				GUC_Tableau1[GUC_Index][NOEUD]=0;
				GUC_Tableau1[GUC_Index][NUM]=0;
				GUC_Tableau1[GUC_Index][ORIENTATION]=0;

	        	GUC_Tableau2[GUC_Index][COLONNE]=0;
				GUC_Tableau2[GUC_Index][LIGNE]=0;
				GUC_Tableau2[GUC_Index][NOEUD]=0;
				GUC_Tableau2[GUC_Index][NUM]=0;
				GUC_Tableau2[GUC_Index][ORIENTATION]=0;
	
	        	GUC_Tableau3[GUC_Index][COLONNE]=0;
				GUC_Tableau3[GUC_Index][LIGNE]=0;
				GUC_Tableau3[GUC_Index][NOEUD]=0;
				GUC_Tableau3[GUC_Index][NUM]=0;
				GUC_Tableau3[GUC_Index][ORIENTATION]=0;
	
	        }
GUC_Index =0;
GUC_Avancement=0;	// permet de rgler l'avance au timer!
GUC_Recalage=0; 	// permet d'indiquer si on a le recalage d'actif 0=> non  1=> oui

//#pragma udata test
GUC_Poids_Cellule=0;		// mesure du poids d'un cellule pour la recherche de sortie
GUC_PoidsCellule=0;		// mesure du poids d'un cellule pour la conversion analogique.
	GUI_Timing20ms = TIMING_20MS;	// indication pour la premiere interruption
	GUC_MoteurDroit = MOTEUR_DROIT_ARRET;
	GUC_MoteurGauche = MOTEUR_GAUCHE_ARRET;
}
	

////////////////////////////////////////////////////////////////////////
////                          LAB_Fonction.c                        ////
////                                                                ////
////  Fonction li au labyrinthe									////
////                 18F242 quartz 20 MHz ou 10Mhz *4 (PLL) = 40Mhz ////
////  Auteur: 	LG					     							////
////  Date:	 22 novembre 2004                                     	////
////                                                                ////
////////////////////////////////////////////////////////////////////////
////        (C) Copyright 2004 - LG				             		////
////								     							////
////////////////////////////////////////////////////////////////////////

/********************************************************
Fonction: LAB_RechercheSortie
Utilisation: Fonction principal du programme appel au boot du PIC
Date: 22/03/2004
Auteur: LG
********************************************************/

void LAB_RechercheSortie(void)
{
// activation du recalage.
GUC_Recalage =1;

// cette fonction permet de simuler une sortie par le plus cours chemin
// hypothses de dpart. on considre que l'on sait o on est dans le labyrinthe, ainsi que l'orientation.
// on considre que les GUC_Poids_Cellule, GUC_PositionX, GUC_PositionY, GUC_Orientation sont dj positionnes
// ces valeurs sont issues de la fonction de reprage utilis en amont.
	GUC_Sortie= 0;
	GUC_Poids_Cellule --; // on dcremente le poids de la cellule pour chercher la suivante, on fait toujours un prdcrement
	do
	{
		GUC_Trouve =0;			// on prpositionne  faux
		GUC_Ordre =0;
	    // fonction de mesure des bords.
	    // utiliser une autre fonction ...
#ifndef DEBUG
	    OS_MesureBords(); // le rsultat est dans GUC_Capteur_Avant, GUC_Capteur_Droit, GUC_Capteur_Gauche, GUC_Capteur_Arriere
//		OS_Lcd_Clear();
//		OS_Lcd_Char(GUC_Capteur_Avant+'0');	// 
//		OS_Lcd_Char(GUC_Capteur_Droit+'0');	// 
//		OS_Lcd_Char(GUC_Capteur_Arriere+'0');	// 
//		OS_Lcd_Char(GUC_Capteur_Gauche+'0');	// 
//		OS_Lcd_Char(GUC_PositionX+'0');	// 
//		OS_Lcd_Char(GUC_PositionY+'0');	// 
//		OS_ClignotementLed400ms(5);	// clignotement pendant 0.4s
//		OS_Lcd_Char(GUC_Poids_Cellule+'0');	// 
//		OS_ClignotementLed400ms(5);	// clignotement pendant 0.4s

#endif
//    ' boucle de test pour savoir comment on va se dplacer par rapport  la mesure!
//    ' en C  remplacer par un switch!
    switch (GUC_Orientation)
    {
	  case 1:	// orientation 1
	  		if( GUC_Capteur_Avant ==0)
	  		{	if(GUC_TAB_SortieT[GUC_PositionY-1][GUC_PositionX]==GUC_Poids_Cellule)
	  			{	
					if(GUC_Trouve == 0)
					{
					GUC_Ordre=1; // on va tout droit
		  			GUC_Trouve=1;
					}
	  			}	
	  		}
	  		if(GUC_Capteur_Droit ==0)
	  		{	if(GUC_TAB_SortieT[GUC_PositionY][GUC_PositionX+1]==GUC_Poids_Cellule)
		  		{	if (GUC_Trouve ==0)
					{
					GUC_Ordre =2;	// on tourne  droite
			  		GUC_Orientation++;
			  		GUC_Trouve=1;
					}		
			  	}	
		  	}
			if(GUC_Capteur_Gauche ==0)
	  		{	
		  		if(GUC_TAB_SortieT[GUC_PositionY][GUC_PositionX-1] == GUC_Poids_Cellule)
		  		{	if (GUC_Trouve ==0)
					{
					GUC_Ordre =4;	// on tourne  gauche
		  			GUC_Orientation --;
		  			GUC_Trouve =1;
					}
		  		}
		  	}
	  		if(GUC_Capteur_Arriere ==0)
	  		{	
		  		if(GUC_TAB_SortieT[GUC_PositionY+1][GUC_PositionX]==GUC_Poids_Cellule)
		  		{ 	if (GUC_Trouve ==0)
					{
					GUC_Ordre =3;	// on recule
			  		GUC_Trouve = 1;
					}
			  	}
		  	}
			// mise  jour de la position
			switch(GUC_Ordre)
			{	case 1:	GUC_PositionY--; break;
				case 2: GUC_PositionX++; break;
				case 3:	GUC_PositionY++; break;
				case 4:	GUC_PositionX--; break;
				default:
						break;	
			}		  	
	  		break;
	  case 2: // orientation 2
			if(GUC_Capteur_Avant ==0)
			{	if(GUC_TAB_SortieT[GUC_PositionY][GUC_PositionX+1]==GUC_Poids_Cellule)
				{
					if (GUC_Trouve ==0)
					{
					GUC_Ordre =1;
					GUC_Trouve =1;
					}
				}		
			}
			if(GUC_Capteur_Droit ==0)
			{	if(GUC_TAB_SortieT[GUC_PositionY+1][GUC_PositionX] ==GUC_Poids_Cellule)
				{	if (GUC_Trouve ==0)
					{
					GUC_Ordre =2;
					GUC_Orientation++; // on tourne  droite
					GUC_Trouve=1;
					}
				}
			}
			if(GUC_Capteur_Gauche ==0)
			{	if(GUC_TAB_SortieT[GUC_PositionY-1][GUC_PositionX]==GUC_Poids_Cellule)
				{	if (GUC_Trouve ==0)
					{
					GUC_Ordre =4;
					GUC_Orientation --;
					GUC_Trouve=1;
					}
				}
			}
			if(GUC_Capteur_Arriere ==0)
			{	
				if(GUC_TAB_SortieT[GUC_PositionY][GUC_PositionX-1]==GUC_Poids_Cellule)
				{	if (GUC_Trouve ==0)
					{
					GUC_Ordre =3;
					GUC_Trouve=1;
					}
				}
			}
			// Mise  jour de la position
			switch(GUC_Ordre)
			{	case 1: GUC_PositionX++; break;
				case 2: GUC_PositionY++; break;
				case 3:	GUC_PositionX--; break;
				case 4: GUC_PositionY--; break;
				default: break;				
			}
	  		break;
	  case 3: // orientation 3
	  		if(GUC_Capteur_Avant ==0)
	  		{	if(GUC_TAB_SortieT[GUC_PositionY+1][GUC_PositionX]==GUC_Poids_Cellule)
		  		{	if (GUC_Trouve ==0)
					{
					GUC_Ordre =1;// on avance
			  		GUC_Trouve=1;
					}
		  		}
		  	}
	  		if(GUC_Capteur_Droit ==0)
	  		{	if(GUC_TAB_SortieT[GUC_PositionY][GUC_PositionX-1]==GUC_Poids_Cellule)
		  		{if (GUC_Trouve ==0)
					{
					GUC_Ordre =2;
			  		GUC_Orientation ++;
			  		GUC_Trouve =1;
					}
			  	}
		  	}
			if(GUC_Capteur_Gauche ==0)
			{	if(GUC_TAB_SortieT[GUC_PositionY][GUC_PositionX+1] ==GUC_Poids_Cellule)
				{	if (GUC_Trouve ==0)
					{
					GUC_Ordre=4;
					GUC_Orientation --;
					GUC_Trouve =1;
					}
				}
			}	
	  		if(GUC_Capteur_Arriere ==0)
	  		{	if(GUC_TAB_SortieT[GUC_PositionY-1][GUC_PositionX] ==GUC_Poids_Cellule)
		  		{	if (GUC_Trouve ==0)
					{
					GUC_Ordre =3;
			  		GUC_Trouve =1;
					}
			  	}
		  	}
			// mise  jour de la position.			
			switch(GUC_Ordre)
			{	case 1:	GUC_PositionY++;	break;
				case 2:	GUC_PositionX--;	break;
				case 3:	GUC_PositionY--;	break;
				case 4:	GUC_PositionX++;	break;
				default: break;
			}
	  		break;
	  case 4: // orientation 4
	  		if(GUC_Capteur_Avant==0)
	  		{	if(GUC_TAB_SortieT[GUC_PositionY][GUC_PositionX-1] ==GUC_Poids_Cellule)
		  		{	if (GUC_Trouve ==0)
					{
					GUC_Ordre=1;
			  		GUC_Trouve=1;
					}
			  	}
		  	}
			if(GUC_Capteur_Droit==0)
			{	if(GUC_TAB_SortieT[GUC_PositionY-1][GUC_PositionX] ==GUC_Poids_Cellule)
				{	if (GUC_Trouve ==0)
					{
					GUC_Ordre=2;
					GUC_Orientation++;
					GUC_Trouve=1;
					}
				}
			}					  	
			if(GUC_Capteur_Gauche==0)
			{	if(GUC_TAB_SortieT[GUC_PositionY+1][GUC_PositionX] ==GUC_Poids_Cellule)
				{	if (GUC_Trouve ==0)
					{
					GUC_Ordre=4;
					GUC_Orientation--;
					GUC_Trouve=1;
					}
				}
			}	  
			if(GUC_Capteur_Arriere==0)
			{	if(GUC_TAB_SortieT[GUC_PositionY][GUC_PositionX+1] ==GUC_Poids_Cellule)
				{	if (GUC_Trouve ==0)
					{
					GUC_Ordre =3;
					GUC_Trouve=1;
					}
				}
			}
			// Mise  jour de la position
			switch (GUC_Ordre)
			{	case 1:	GUC_PositionX--; break;
				case 2:	GUC_PositionY--; break;
				case 3:	GUC_PositionX++; break;
				case 4:	GUC_PositionY++; break;
				default: break;
			}
	  		break;
    } // fin du switch GUC_Orientation 
    // on regarde si on ne dborde pas sur l'orientation
	if(GUC_Orientation == 5)
		GUC_Orientation =1;
	if(GUC_Orientation == 0)
		GUC_Orientation =4;

#ifndef DEBUG

//#endif
    //dplacement  faire
	switch(GUC_Ordre)
	{
		case 1:
				OS_Avancer(DISTANCE_AVANT_40CM);				// avancer de 40cm
				break;
		case 2:
				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				OS_MesureAccelerationStatique();
				OS_TournerDroite(ROTATION_DROITE_90);			// tourner  droite de 90
				OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
//				OS_MesureAccelerationStatique();
				OS_Avancer(DISTANCE_AVANT_30CM);				// avancer de 40cm
//				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				break;
		case 3:
				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				OS_Reculer(DISTANCE_ARRIERE_40CM);				// reculer de 40cm
//				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				break;
		case 4:
				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				OS_MesureAccelerationStatique();
				OS_TournerGauche(ROTATION_GAUCHE_90);			// tourner  gauche de 90
				OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
//				OS_MesureAccelerationStatique();
				OS_Avancer(DISTANCE_AVANT_30CM);				// avancer de 40cm
//				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				break;
		default: break;
	} 
#endif    

//     test pour savoir si on au niveau de la sortie
	if(GUC_Poids_Cellule ==1) // la cellule proche de la sortie a un poids de 1
	{
        // on va tester sur quel bords du tableau on est!
/*        if((GUC_PositionX ==0)&&(GUC_PositionY == 4))
        {	if(GUC_Orientation == 1)	GUC_Ordre =4; // tourner  gauche
	        if(GUC_Orientation == 2)	GUC_Ordre =3; // reculer
	        if(GUC_Orientation == 3)	GUC_Ordre =2; // tourner  droite
	        if(GUC_Orientation == 4)	GUC_Ordre =1; // on avance
	    }
*/
		if((GUC_PositionX ==8)&&(GUC_PositionY == 4))
		{
			if(GUC_Orientation == 1)	GUC_Ordre =2; // tourner  droite
	        if(GUC_Orientation == 2)	GUC_Ordre =1; // avancer
	        if(GUC_Orientation == 3)	GUC_Ordre =4; // tourner  gauche
	        if(GUC_Orientation == 4)	GUC_Ordre =3; // reculer
		}        
/*		if(GUC_PositionY == 0)
		{
			if(GUC_Orientation == 1)	GUC_Ordre =1; // avancer
	        if(GUC_Orientation == 2)	GUC_Ordre =4;  // tourner  gauche
	        if(GUC_Orientation == 3)	GUC_Ordre =3; // reculer
	        if(GUC_Orientation == 4)	GUC_Ordre =2; // tourner  droite
		}
		if(GUC_PositionY ==8)
		{
			if(GUC_Orientation == 1)	GUC_Ordre =3; // reculer
	        if(GUC_Orientation == 2)	GUC_Ordre =2;  // tourner  droite
	        if(GUC_Orientation == 3)	GUC_Ordre =1; // avancer
	        if(GUC_Orientation == 4)	GUC_Ordre =4; // tourner  gauche
		}	
*/
#ifndef DEBUG
       	OS_MesureAccelerationStatique();

        //dernier mouvement  faire!
		switch(GUC_Ordre)
		{
			case 1:
				OS_Avancer(DISTANCE_AVANT_40CM);				// avancer de 40cm
				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				break;
			case 2:
				OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
			 	OS_MesureAccelerationStatique();
				OS_TournerDroite(ROTATION_DROITE_90);			// tourner  droite de 90
				OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
				OS_Avancer(DISTANCE_AVANT_40CM);				// avancer de 40cm
//				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				break;
			case 3:
				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				OS_Reculer(DISTANCE_ARRIERE_40CM);				// reculer de 40cm
//				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				break;
			case 4:
				OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
			 	OS_MesureAccelerationStatique();
				OS_TournerGauche(ROTATION_GAUCHE_90);			// tourner  gauche de 90
//				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				OS_Avancer(DISTANCE_AVANT_40CM);				// avancer de 40cm
//				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				break;
			default: break;
		}    
#endif
		GUC_Sortie = 1;
  	}  
		OS_Lcd_Clear();
		OS_Lcd_Char(GUC_PositionX+'0');	// 
		OS_Lcd_Char(GUC_PositionY+'0');	// 
		OS_Lcd_Char(GUC_Orientation+'0');	// 

    GUC_Poids_Cellule--;			// on dcremente le poids de la cellule pour le prochain tour
	}
	while (GUC_Sortie ==0) ;      // on sort si on a trouv la sortie!

}	// fin de la fonction LAB_RechercheSortie


/********************************************************
Fonction: LAB_ReperagePosition
Utilisation: Fonction pour la recherche de la position dans le labyrinthe
Date: 22/03/2004
Auteur: LG
********************************************************/

uchar LAB_ReperagePosition(void)
{
// cette fonction va grer la recherche de la position dans le labyrinthe.
// avant d'appeler la fonction qui gre la recherche de la sortie

// dsactivation du recalage!
	GUC_Recalage =0;
 
// initialisation des variables correspondant Au dernier mouvement fait par le robot;
	GUC_Avance = 0;		//
	GUC_Recule = 0;		// 	
	GUC_Droite = 0;		// 	
	GUC_Gauche = 0;		// 	
	GUC_Mesure1 =0;
	GUC_Mesure2 = 0;

// Recherche de la position de dpart.
// on commence par mesurer la premire cellule
#ifndef DEBUG
	OS_ConversionAN();	// le rsultat est dans GUC_Poids_Cellule
#endif
	GUC_Mesure1 = GUC_PoidsCellule;
// recherche dans le tableau si on a plusieurs rsultat
	GUC_NbResultat =LAB_RechercheTab(GUC_Mesure1,1);
#ifndef DEBUG
 //  	OS_MesureAccelerationStatique();
#endif
// on regarde si on a besoin de se dplacer d'une case.
//if (GUC_NbResultat > 1 )
//{   // il faut donc se dplacer d'une case.
    // on regarde vers ou on se dplace.
#ifndef DEBUG
    if ( GUC_Mesure1 > 63) 
    {// on avance
		OS_Avancer(DISTANCE_AVANT_40CM);		// on avance une case
//	OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
        GUC_Avance = 1;	// on indique qu'on a avanc d'une case
    }
    else
    {// on tourne  droite.
	    if(GUC_Mesure1 >15)
		{	OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
	      	OS_MesureAccelerationStatique();
	     	OS_TournerDroite(ROTATION_DROITE_90);	//de 90
			OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
			OS_Avancer(DISTANCE_AVANT_30CM);	// on avance d'une case
//			OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
			GUC_Droite =1;
        }
        else
        {	// on recule?
	        if(GUC_Mesure1 >7)
	        {
				OS_ClignotementLed400ms(2);	// clignotement pendant 0.4s
				OS_Reculer(DISTANCE_ARRIERE_40CM);	// on recule d'une case
//				OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
				GUC_Recule =1;
            }
            else
            {// on tourne  gauche
				OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
	      		OS_MesureAccelerationStatique();
				OS_TournerGauche(ROTATION_GAUCHE_90);	//de 90
				OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
	   			OS_Avancer(DISTANCE_AVANT_30CM);	// on avance d'une case
//				OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
         	    GUC_Gauche =1; 
			}
		}
    }
#endif
// fin du premier dplacement, si on a eu besoin
    
    // on refait une mesure.
#ifndef DEBUG
   	OS_ConversionAN();					// le rsultat est dans GUC_PoidsCellule
#endif

	GUC_Mesure2 = GUC_PoidsCellule;		// sauvegarde du rsultat.
	GUC_NbResultat2 =LAB_RechercheTab(GUC_Mesure2,2);

    
	if (GUC_NbResultat2 != 1)
	{	// on va chercher dans le tableau ou on est.
        // on va balayer le tableau 1 et tester toutes les combinaisons dans le tableau 2
        GUC_Index = 0;   // position dans le tableau 1
        GUC_Index3 = 0;  // position dans le tableau 3 pour recopie et sauvegarde des solutions de T2 potientielle
        while (GUC_Index < GUC_NbResultat)
        {
            GUC_Index2 = 0;  // position dans le tableau 2
            GUC_Solution = 0;    // permettra de dire si une case de tableau 1 correspond  une case de tableau 2
                            // normalement il n'y a qu'une solution de T1 => T2 par ligne de T1
                            // si  la fin du blayage de T2, solution =0 alors la ligne de T1 est  effacer car c'est pas une solution
			while (GUC_Index2 < GUC_NbResultat2)
			{// on regarde l'orientation, pour savoir si la ligne courante est possible
				if((GUC_Avance == 1) &&( GUC_Tableau1[GUC_Index][ORIENTATION] == GUC_Tableau2[GUC_Index2][ORIENTATION]))
				{// on potentiellement une ligne OK en avanant.
					if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==1) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE] -1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
						GUC_Solution ++;
					if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==2) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]+1)))
						GUC_Solution ++;
					if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==3) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE]+1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
						GUC_Solution ++;
					if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==4) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]-1)))
						GUC_Solution ++;
                    //  on passe  ligne suivante de T2! mais avant on test Solution voir plus bas
                }
                else
                {// on va regarder dans le cas o on a reculer.
	                if((GUC_Recule == 1)&&(GUC_Tableau1[GUC_Index][ORIENTATION] == GUC_Tableau2[GUC_Index2][ORIENTATION]))
	                {// on a potentiellement une ligne OK en reculant
						if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==1) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE] +1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
							GUC_Solution ++;
						if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==2) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]-1)))
							GUC_Solution ++;
						if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==3) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE]-1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
							GUC_Solution ++;
						if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==4) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]+1)))
							GUC_Solution ++;
                        // on passe  ligne suivante de T2! mais avant on test Solution voir plus bas
                    }
                    else
                    {// on va regarder dans le cas o on a tourn  droite.
	                    if (GUC_Droite == 1)
	                    {// il faut grer le passage de 4 => 1 dans le sens de rotation  !
		                    if (((GUC_Tableau1[GUC_Index][ORIENTATION]+1) == GUC_Tableau2[GUC_Index2][ORIENTATION]) || ((GUC_Tableau1[GUC_Index][ORIENTATION]==4) &&(GUC_Tableau2[GUC_Index][ORIENTATION] == 1)))
		                    {//on a potentiellement une ligne OK en tournant  droite.
								if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==1) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]+1)))
									GUC_Solution ++;
								if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==2) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE]+1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
									GUC_Solution ++;
								if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==3) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]-1)))
									GUC_Solution ++;
								if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==4) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE]-1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
									GUC_Solution ++;
                                // on passe  ligne suivante de T2! mais avant on test Solution voir plus bas
                            }
                        }
                        else
                        {// on va regarder dans le cas o on a tourn  gauche
	                        if(GUC_Gauche== 1) 
	                        {
       		                    if (((GUC_Tableau1[GUC_Index][ORIENTATION]-1) == GUC_Tableau2[GUC_Index2][ORIENTATION]) || ((GUC_Tableau1[GUC_Index][ORIENTATION]==1) &&(GUC_Tableau2[GUC_Index][ORIENTATION] == 4)))
                                {
									if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==1) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]-1)))
										GUC_Solution ++;
									if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==2) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE]-1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
										GUC_Solution ++;
									if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==3) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]+1)))
										GUC_Solution ++;
									if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==4) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE]+1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
										GUC_Solution ++;
                                    // on passe  ligne suivante de T2! mais avant on test Solution voir plus bas
                                }
                            }
                        }
                    }
                }
                // en thorie quand on arrive ici et que pour une ligne de T1 on a dj Solution =1 c'est que c'est fini on ne doit plus trouver d'autre combinaison
                // mais ceci peut dpendre des labyrinthe alors comme je n'ai pas trouv d'exemple on continue le balayage.
                
                // on en profite pour sauver le ligne de T2 qui matche, et on la met dans le tableau T3
                if(GUC_Solution ==1)
                {
					GUC_Tableau3[GUC_Index3][COLONNE]=GUC_Tableau2[GUC_Index2][COLONNE];
					GUC_Tableau3[GUC_Index3][LIGNE]=GUC_Tableau2[GUC_Index2][LIGNE];
					GUC_Tableau3[GUC_Index3][NOEUD]=GUC_Tableau2[GUC_Index2][NOEUD];
					GUC_Tableau3[GUC_Index3][NUM]=GUC_Tableau2[GUC_Index2][NUM];
					GUC_Tableau3[GUC_Index3][ORIENTATION]=GUC_Tableau2[GUC_Index2][ORIENTATION];
					GUC_Index3 ++;
					GUC_Solution ++;	// ceci est fait car on en peut pas avoir deux cases du tableau 2 qui succede une case du tableau 1
				}
                GUC_Index2 ++; // on passe  ligne suivante du tableau 2
            }// fin du while du balayage du tableau 2

        // on regarde si on a trouv une solution = 1 au moins. Si c'est le cas on garde la ligne dans T1 sinon on efface la ligne, mise  0 des parametres!
        // la sauvegarde de la solution dans le tableau 2 est dj faite. En fait c'est utile pour le dbug. Dans la suite on pour sauter cette tape
        // car si on doit faire une nouvelle recherche alors on partira du tableau 2!
        if(GUC_Solution ==0)
        {
			GUC_Tableau1[GUC_Index][COLONNE]=0;
			GUC_Tableau1[GUC_Index][LIGNE]=0;
			GUC_Tableau1[GUC_Index][NOEUD]=0;
			GUC_Tableau1[GUC_Index][NUM]=0;
			GUC_Tableau1[GUC_Index][ORIENTATION]=0;
        }
	    GUC_Index ++;	// on passe  la ligne suivante du tableau 1
        }	// fin du while sur le balayage du tableau 1
	

	    // on a fini de balayer le tableau 1
	    // balayage et nettoyage des ligne  0 dans le T1, il ne reste  l'issue que les lignes utiles.
	    // cette tape n'est utile que pour le dbug! A l'avnir on ne la mettra pas car le tableau 2 n'est plus utile.
	    GUC_Index2 = 0;
	    GUC_Index = 0;
	    while (GUC_Index < GUC_NbResultat)
	    {
			if((GUC_Tableau1[GUC_Index][COLONNE] == 0)&&(GUC_Tableau1[GUC_Index][LIGNE] == 0)&&(GUC_Tableau1[GUC_Index][NOEUD] == 0)&&(GUC_Tableau1[GUC_Index][NUM] == 0)&&(GUC_Tableau1[GUC_Index][ORIENTATION] == 0))
			    //on saute on ne recopie pas la ligne
			    ;
			else
			{   //on recopie la ligne avec dcalage si necessaire
				GUC_Tableau1[GUC_Index2][COLONNE]=GUC_Tableau1[GUC_Index][COLONNE];
				GUC_Tableau1[GUC_Index2][LIGNE]=GUC_Tableau1[GUC_Index][LIGNE];
				GUC_Tableau1[GUC_Index2][NOEUD]=GUC_Tableau1[GUC_Index][NOEUD];
				GUC_Tableau1[GUC_Index2][NUM]=GUC_Tableau1[GUC_Index][NUM];
				GUC_Tableau1[GUC_Index2][ORIENTATION]=GUC_Tableau1[GUC_Index][ORIENTATION];
				GUC_Index2++;	//  l'issue GUC_Index2 indique le nombre de rsultat trouv!
			}
			GUC_Index++;
	    }// fin du while
	
		//effacement du reste du tableau1  ' utile que pour le debug.
	    while ( GUC_Index2 < 11)
	    {
			GUC_Tableau1[GUC_Index2][COLONNE]=0;
			GUC_Tableau1[GUC_Index2][LIGNE]=0;
			GUC_Tableau1[GUC_Index2][NOEUD]=0;
			GUC_Tableau1[GUC_Index2][NUM]=0;
			GUC_Tableau1[GUC_Index2][ORIENTATION]=0;
			GUC_Index2++;
		}
		// rajout dans le code C pour optimisation de la recherche suivante....
		GUC_NbResultat= GUC_Index3;	
		
	    // bon est ce qu'on sait o on est ? C'est la valeur de index3 qui peut nous le dire.
	    if(GUC_Index3 !=1)
	    {	// on ne sait pas o on est donc on doit poursuivre la recherche!
	        // on va recopier le tableau3 dans 1 on a plusieurs ligne
	        // nettoyage du tableau1 d'abords.
	        for(GUC_Index=0;GUC_Index<11;GUC_Index++)
	        {
		   		GUC_Tableau1[GUC_Index][COLONNE]=0;
				GUC_Tableau1[GUC_Index][LIGNE]=0;
				GUC_Tableau1[GUC_Index][NOEUD]=0;
				GUC_Tableau1[GUC_Index][NUM]=0;
				GUC_Tableau1[GUC_Index][ORIENTATION]=0;
	
		    }
			// recopie
			for(GUC_Index=0;GUC_Index<=GUC_Index3;GUC_Index++)
			{
	  			GUC_Tableau1[GUC_Index][COLONNE]=GUC_Tableau3[GUC_Index][COLONNE];
				GUC_Tableau1[GUC_Index][LIGNE]=GUC_Tableau3[GUC_Index][LIGNE];
				GUC_Tableau1[GUC_Index][NOEUD]=GUC_Tableau1[GUC_Index][NOEUD];
				GUC_Tableau1[GUC_Index][NUM]=GUC_Tableau3[GUC_Index][NUM];
				GUC_Tableau1[GUC_Index][ORIENTATION]=GUC_Tableau3[GUC_Index][ORIENTATION];
	        }
	        // nettoyage du tableau2 et du tableau 3
	        for(GUC_Index =0;GUC_Index<11;GUC_Index++)
	        {
	        	GUC_Tableau2[GUC_Index][COLONNE]=0;
				GUC_Tableau2[GUC_Index][LIGNE]=0;
				GUC_Tableau2[GUC_Index][NOEUD]=0;
				GUC_Tableau2[GUC_Index][NUM]=0;
				GUC_Tableau2[GUC_Index][ORIENTATION]=0;
	
	        	GUC_Tableau3[GUC_Index][COLONNE]=0;
				GUC_Tableau3[GUC_Index][LIGNE]=0;
				GUC_Tableau3[GUC_Index][NOEUD]=0;
				GUC_Tableau3[GUC_Index][NUM]=0;
				GUC_Tableau3[GUC_Index][ORIENTATION]=0;
	
	        }
	    	// il faut donc se dplacer d'une case.
	    	GUC_Avance =0;
	    	GUC_Droite =0;
	    	GUC_Recule=0;
	    	GUC_Gauche =0;
#ifndef DEBUG	
		//   	OS_MesureAccelerationStatique();

	        // on regarde vers ou on se dplace.
	        if(GUC_Mesure2 > 63) // on a dj fait la mesure plus haut!
	        {// on avance
				OS_Avancer(DISTANCE_AVANT_40CM);	
//				OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
	    	    GUC_Avance = 1;	// on indique qu'on a avanc d'une case
		    }
		    else
		    {// on tourne  droite.
			    if(GUC_Mesure2 >15)
			    {
					OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
				   	OS_MesureAccelerationStatique();
					OS_TournerDroite(ROTATION_DROITE_90);	//de 90
					OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
		    		OS_Avancer(DISTANCE_AVANT_30CM);	
//					OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
					GUC_Droite =1;
		        }
		        else
		        {	// on recule?
			        if(GUC_Mesure2 >7)
			        {	// en fait on va tourner  droite car on a un cul de sac potentiellement, donc on repart pour un tour
						OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s	
					   	OS_MesureAccelerationStatique();
						OS_TournerDroite(ROTATION_DROITE_90);	//de 90
						OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
						OS_Reculer(DISTANCE_ARRIERE_20CM);
//						OS_Reculer(DISTANCE_ARRIERE_40CM);
						OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
						GUC_Recule =1;
						return 0;
		            }
		            else
		            {// on tourne  gauche
						OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
					   	OS_MesureAccelerationStatique();
						OS_TournerGauche(ROTATION_GAUCHE_90);	//de 90
						OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
		               	OS_Avancer(DISTANCE_AVANT_30CM);	
	//					OS_ClignotementLed400ms(1);	// clignotement pendant 0.4s
		         	    GUC_Gauche =1; 
					}
				}
		    }	        
	        // fin du deuxime dplacement.
	        
	      	OS_ConversionAN();					// le rsultat est dans GUC_PoidsCellule
#endif	      	
			GUC_Mesure2 = GUC_PoidsCellule;		// sauvegarde du rsultat.
			GUC_NbResultat2 =LAB_RechercheTab(GUC_Mesure2,2); // on recherche dans la table en ROM les valeurs qui vont bien!

	        
	        // on refait une recherche  partir de tableau1 et 2 et on mettre les solutions dans tableau 3, normalement cette fois-ci il n'en reste qu'une.
	        // il faudra nanmoins traiter un cas qui aurait causer un aller et retour sur la meme case... histoire du cul de sac pourvu que cela n'arrive pas!!!
	        // on va chercher dans le tableau ou on est.
	        // on va balayer le tableau 1 et tester toutes les combinaisons dans le tableau 2
	        GUC_Index = 0 ;  // position dans le tableau 1
	        GUC_Index3 = 0 ; // position dans le tableau 3 pour recopie et sauvegarde des solutions de T2
	        while (GUC_Index < GUC_NbResultat)
	        {
	        	GUC_Index2 = 0 ; // position dans le tableau 2
	            GUC_Solution = 0  ;  // permettra de dire si une case de tableau 1 correspond  une case de tableau 2
	            // normalement il n'y a qu'une solution de T1 => T2 par ligne de T1
	            // si  la fin du blayage de T2, solution =0 alors la ligne de T1 est  effacer car c'est pas une solution
	            while (GUC_Index2 < GUC_NbResultat2)
	            {// on regarde l'orientation, pour savoir si la ligne courante est possible
		        	if((GUC_Avance==1)&&(GUC_Tableau1[GUC_Index][ORIENTATION]==GUC_Tableau2[GUC_Index2][ORIENTATION]))
		        	{// on potentiellement une ligne OK en avanant.
			        	if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==1) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE] -1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
							GUC_Solution ++;
						if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==2) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]+1)))
							GUC_Solution ++;
						if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==3) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE]+1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
							GUC_Solution ++;
						if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==4) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]-1)))
							GUC_Solution ++;
	                    // on passe  ligne suivante de T2! mais avant on test Solution voir plus bas
					}
					else
					{
	                 // on va regarder dans le cas o on a reculer.
		   	        	if((GUC_Recule==1)&&(GUC_Tableau1[GUC_Index][ORIENTATION]==GUC_Tableau2[GUC_Index2][ORIENTATION]))
		   	        	{// on a potentiellement une ligne OK en reculant
				        	if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==1) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE] +1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
								GUC_Solution ++;
							if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==2) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]-1)))
								GUC_Solution ++;
							if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==3) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE]-1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
								GUC_Solution ++;
							if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==4) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]+1)))
								GUC_Solution ++;
	                       	// on passe  ligne suivante de T2! mais avant on test Solution voir plus bas
	                    }
	                    else
	                    {	// on va regarder dans le cas o on a tourn  droite.
		                	if(GUC_Droite ==1)
		                	{    // il faut grer le passage de 4 => 1 dans le sens de rotation  !
			                    if (((GUC_Tableau1[GUC_Index][ORIENTATION]+1) == GUC_Tableau2[GUC_Index2][ORIENTATION]) || ((GUC_Tableau1[GUC_Index][ORIENTATION]==4) &&(GUC_Tableau2[GUC_Index][ORIENTATION] == 1)))
			                    {//on a potentiellement une ligne OK en tournant  droite.
									if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==1) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]+1)))
										GUC_Solution ++;
									if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==2) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE]+1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
										GUC_Solution ++;
									if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==3) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]-1)))
										GUC_Solution ++;
									if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==4) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE]-1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
										GUC_Solution ++;
	                                // on passe  ligne suivante de T2! mais avant on test Solution voir plus bas
	                            }
	                        }
	                        else
	                        {// on va regarder dans le cas o on a tourn  gauche
		                        if(GUC_Gauche== 1) 
		                        {
	       		                    if (((GUC_Tableau1[GUC_Index][ORIENTATION]-1) == GUC_Tableau2[GUC_Index2][ORIENTATION]) || ((GUC_Tableau1[GUC_Index][ORIENTATION]==1) &&(GUC_Tableau2[GUC_Index][ORIENTATION] == 4)))
	                                {
										if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==1) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]-1)))
											GUC_Solution ++;
										if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==2) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE]-1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
											GUC_Solution ++;
										if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==3) && (GUC_Tableau2[GUC_Index2][LIGNE] == GUC_Tableau1[GUC_Index][LIGNE]) && (GUC_Tableau2[GUC_Index2][COLONNE]==(GUC_Tableau1[GUC_Index][COLONNE]+1)))
											GUC_Solution ++;
										if ( (GUC_Tableau1[GUC_Index][ORIENTATION]==4) && (GUC_Tableau2[GUC_Index2][LIGNE] == (GUC_Tableau1[GUC_Index][LIGNE]+1)) && (GUC_Tableau2[GUC_Index2][COLONNE]==GUC_Tableau1[GUC_Index][COLONNE]))
											GUC_Solution ++;
	                                    // on passe  ligne suivante de T2! mais avant on test Solution voir plus bas
	                                }
	                            }
	                        }
	                    }	
	                }     
	                // en thorie quand on arrive ici et que pour une ligne de T1 on a dj Solution =1 c'est que c'est fini on ne doit plus trouver d'autre combinaison
	                // mais ceci peut dpendre des labyrinthe alors comme je n'ai pas trouv d'exemple on continue le balayage.
	                // on en profite pour sauver le ligne de T2 qui matche, et on la met dans le tableau T3
	                if(GUC_Solution ==1)
	                {
						GUC_Tableau3[GUC_Index3][COLONNE]=GUC_Tableau2[GUC_Index2][COLONNE];
						GUC_Tableau3[GUC_Index3][LIGNE]=GUC_Tableau2[GUC_Index2][LIGNE];
						GUC_Tableau3[GUC_Index3][NOEUD]=GUC_Tableau2[GUC_Index2][NOEUD];
						GUC_Tableau3[GUC_Index3][NUM]=GUC_Tableau2[GUC_Index2][NUM];
						GUC_Tableau3[GUC_Index3][ORIENTATION]=GUC_Tableau2[GUC_Index2][ORIENTATION];
						GUC_Index3 ++;
						GUC_Solution ++;	// ceci est fait car on en peut pas avoir deux cases du tableau 2 qui succede une case du tableau 1
					}
	                GUC_Index2 ++; // on passe  ligne suivante du tableau 2
	           	}	// fin du while du balayage du tableau 2
	            // on regarde si on a trouv une solution = 1 au moins. Si c'est le cas on garde la ligne dans T1 sinon on efface la ligne, mise  0 des parametres!
	            // la sauvegarde de la solution dans le tableau 2 est dj faite. En fait c'est utile pour le dbug. Dans la suite on pour sauter cette tape
	            // car si on doit faire une nouvelle recherche alors on partira du tableau 2!
		        if(GUC_Solution ==0)
		        {
					GUC_Tableau1[GUC_Index][COLONNE]=0;
					GUC_Tableau1[GUC_Index][LIGNE]=0;
					GUC_Tableau1[GUC_Index][NOEUD]=0;
					GUC_Tableau1[GUC_Index][NUM]=0;
					GUC_Tableau1[GUC_Index][ORIENTATION]=0;
		        }
		    	GUC_Index ++; // on passe  la ligne suivante du tableau 1.
	       	}// fin du while du balayage du tableau 1
                  
            // attention il y aura un cas  traiter si on par on bouge et on revient la o on tait!
            // arriv ici le rsultat est dans la premire ligne du tableau 3! on recopie dans la premire ligne du tableau 1!
            GUC_Tableau1[0][COLONNE]=GUC_Tableau3[0][COLONNE];
            GUC_Tableau1[0][LIGNE]=GUC_Tableau3[0][LIGNE];
            GUC_Tableau1[0][NOEUD]=GUC_Tableau3[0][NOEUD];
            GUC_Tableau1[0][NUM]=GUC_Tableau3[0][NUM];
            GUC_Tableau1[0][ORIENTATION]=GUC_Tableau3[0][ORIENTATION];
		}
		else
		{  	//  issue du deuxime mouvement!
   		   	//	on sait ou on est , la solution est dans la premire ligne du tableau 3
        	// 	on la recopie dans la premire ligne du tableau 1
            GUC_Tableau1[0][COLONNE]=GUC_Tableau3[0][COLONNE];
            GUC_Tableau1[0][LIGNE]=GUC_Tableau3[0][LIGNE];
            GUC_Tableau1[0][NOEUD]=GUC_Tableau3[0][NOEUD];
            GUC_Tableau1[0][NUM]=GUC_Tableau3[0][NUM];
            GUC_Tableau1[0][ORIENTATION]=GUC_Tableau3[0][ORIENTATION];
        }
    }
    else
    {// issue du premier mouvement
    // on sait ou on est car il n'y a qu'un rsultat, mais en gros c'est un cas qui se produit rarement!
    //La position de se trouve dans la premire ligne du tableau 2
    // on la recopie dans la premire ligne du tableau 1
    	GUC_Tableau1[0][COLONNE]=GUC_Tableau2[0][COLONNE];
    	GUC_Tableau1[0][LIGNE]=GUC_Tableau2[0][LIGNE];
    	GUC_Tableau1[0][NOEUD]=GUC_Tableau2[0][NOEUD];
    	GUC_Tableau1[0][NUM]=GUC_Tableau2[0][NUM];
    	GUC_Tableau1[0][ORIENTATION]=GUC_Tableau2[0][ORIENTATION];
	}
//}
//else
//{//on sait ou on est! On n'a pas besoin de se dplacer!
//la position se trouve dans la premire ligne du tableau 1 car on n'a qu'une solution
//}


// une fois qu'on sait ou on est il n'y a plus qu' aller vers la sortie!!! La position et l'orientation se trouve dans la premire ligne du tableau 1
// la solution est dans la premire ligne de tableau 1
	GUC_PositionY =    	GUC_Tableau1[0][LIGNE] -1;
	GUC_PositionX = 	GUC_Tableau1[0][COLONNE] -1;
	GUC_Orientation = 	GUC_Tableau1[0][ORIENTATION];
	GUC_Poids_Cellule=	GUC_TAB_SortieT[GUC_PositionY][GUC_PositionX]; // on initialise la vrai valeur du poids de la cellule par rapport  la sortie
// cas spciale si on est pres de la sortie case X=7, Y=5, orientation 2, coordonnes vrai dans ce cas il y a deux solutions qui match
// on avance !
	if ((GUC_PositionX == 7) && (GUC_PositionY == 5)&& (GUC_Orientation== 2))     //( GUC_Index3 >1)
		OS_Avancer(DISTANCE_AVANT_40CM);	

return 1;
}// fin de la fonction void LAB_ReperagePosition(void)

/********************************************************
Fonction: LAB_RechercheTab
Utilisation: Fonction de recherche dans un tableau
Date: 27/03/2004
Auteur: LG
********************************************************/

uchar LAB_RechercheTab(uchar LUC_Mesure,uchar LUC_NumeroRecherche)
{
uchar LUC_NombreResultat=0;
uint i;
i=0;
for(i=0;i<324;i++)
{
	if(GUC_TAB_Tableau[i][NOEUD] == LUC_Mesure)
	{
   		// on recopie les valeurs dans le tableau qui va bien en fonction du numro de recherche
		if(LUC_NumeroRecherche == 1)
		{
			GUC_Tableau1[LUC_NombreResultat][COLONNE] = GUC_TAB_Tableau[i][COLONNE];
			GUC_Tableau1[LUC_NombreResultat][LIGNE] = GUC_TAB_Tableau[i][LIGNE];
			GUC_Tableau1[LUC_NombreResultat][NOEUD] = GUC_TAB_Tableau[i][NOEUD];
			GUC_Tableau1[LUC_NombreResultat][NUM] = GUC_TAB_Tableau[i][NUM];
			GUC_Tableau1[LUC_NombreResultat][ORIENTATION] = GUC_TAB_Tableau[i][ORIENTATION];
		}
		if(LUC_NumeroRecherche == 2)
		{
			GUC_Tableau2[LUC_NombreResultat][COLONNE] = GUC_TAB_Tableau[i][COLONNE];
			GUC_Tableau2[LUC_NombreResultat][LIGNE] = GUC_TAB_Tableau[i][LIGNE];
			GUC_Tableau2[LUC_NombreResultat][NOEUD] = GUC_TAB_Tableau[i][NOEUD];
			GUC_Tableau2[LUC_NombreResultat][NUM] = GUC_TAB_Tableau[i][NUM];
			GUC_Tableau2[LUC_NombreResultat][ORIENTATION] = GUC_TAB_Tableau[i][ORIENTATION];
		}
		if(LUC_NumeroRecherche == 3)
		{
			GUC_Tableau3[LUC_NombreResultat][COLONNE] = GUC_TAB_Tableau[i][COLONNE];
			GUC_Tableau3[LUC_NombreResultat][LIGNE] = GUC_TAB_Tableau[i][LIGNE];
			GUC_Tableau3[LUC_NombreResultat][NOEUD] = GUC_TAB_Tableau[i][NOEUD];
			GUC_Tableau3[LUC_NombreResultat][NUM] = GUC_TAB_Tableau[i][NUM];
			GUC_Tableau3[LUC_NombreResultat][ORIENTATION] = GUC_TAB_Tableau[i][ORIENTATION];
		}
	LUC_NombreResultat ++; // on incrmente le nombre de rsultat
	}
}
return LUC_NombreResultat;
}// fin de la fonction recherche


////////////////////////////////////////////////////////////////////////
////                          OS_Interface.c                        ////
////                                                                ////
////  Fonction grant les interfaces du CPU	 						////
////                 18F242 quartz 20 MHz ou 10Mhz *4 (PLL) = 40Mhz ////
////  Auteur: 	LG					     							////
////  Date:	 15 novembre 2003                                     	////
////                                                                ////
////////////////////////////////////////////////////////////////////////
////        (C) Copyright 2003 - LG				             		////
////								     							////
////////////////////////////////////////////////////////////////////////

/********************************************************
Fonction: OS_ClignotementLed400ms
Utilisation: Fonction de clignotement de la led
Date: 15/11/2003
Auteur: LG
********************************************************/
void OS_ClignotementLed400ms(uchar LUC_tempo)
{
/* Dclaration de variable locales */ 

/* Dbut du corps de la fonction*/
	while ( LUC_tempo-- > 0)
	{
	PORTCbits.RC0 = 0; // teindre la led.
	Delay10KTCYx(100); // attente de 0.2s
	PORTCbits.RC0 = 1; // allumer la led.
	Delay10KTCYx(100); // attente de 0.2s
	}
}
//********************************************************
//Fonction: OS_EtatBouton
//Utilisation: Fonction qui renvoie l'etat du bouton connecter sur RA5
//Date: 20/11/2003
//Auteur: LG
//********************************************************
uchar OS_EtatBouton(void)
{// actif bas sur la carte PICObot!
	return PORTAbits.RA5;
}
//********************************************************
//Fonction: OS_MesureBords(void)
//Utilisation: Fonction pour la mesure de bords juste dans la cellule courante, utilis par la fonction de recherche de sortie de labyrinthe
// Mets  jour les variables GUC_Capteur_Avant, GUC_Capteur_Droit, GUC_Capteur_Gauche, GUC_Capteur_Arriere
//Date: 20/11/2003
//Auteur: LG
//********************************************************
void OS_MesureBords(void)	// fonction utilis pour la mesure des bords. 
{	// dclaration de variable locale
	uint LUI_ResultatConversion;
	LUI_ResultatConversion=0;
	
	// dclaration du corps de la fonction
	// remise  zro des variable globale
	GUC_Capteur_Avant=0;
	GUC_Capteur_Droit=0;
	GUC_Capteur_Gauche=0;
	GUC_Capteur_Arriere=0;
	
	OpenADC(ADC_FOSC_64 & ADC_5ANA_0REF & ADC_RIGHT_JUST, ADC_INT_OFF & ADC_CH0);
	Delay100TCYx(1); // attente pour le condensateur
	ConvertADC();  // lancement de la conversion sur le canal 0
	while ( BusyADC());
	LUI_ResultatConversion = ReadADC();
	SetChanADC(ADC_CH1); // slection de le canal 1
	Delay100TCYx(1); // attente pour le condensateur
	ConvertADC();  // lancement de la conversion sur le canal 1
	if (((uchar)DISTANCE_30CM_AVANT )< ((uchar) (LUI_ResultatConversion >>1)))
	{
		GUC_Capteur_Avant =1;		// indique qu'il y a un mur devant.
	}
	while ( BusyADC());
	LUI_ResultatConversion = ReadADC();
	SetChanADC(ADC_CH2); // slection de le canal 2
	Delay100TCYx(1); // attente pour le condensateur
	ConvertADC();  // lancement de la conversion sur le canal 2
	if (((uchar)DISTANCE_30CM_DROIT )< ((uchar) (LUI_ResultatConversion >>1)))
	{
		GUC_Capteur_Droit =1;		// indique qu'il y a un mur devant.
	}
	while ( BusyADC());
	LUI_ResultatConversion = ReadADC();
	SetChanADC(ADC_CH3); // slection de le canal 3
	Delay100TCYx(1); // attente pour le condensateur
	ConvertADC();  // lancement de la conversion sur le canal 3
	// calcul avec le canal 2
	if (((uchar)DISTANCE_30CM_ARRIERE )< ((uchar) (LUI_ResultatConversion >>1)))
	{
		GUC_Capteur_Arriere =1;		// indique qu'il y a un mur devant.
	}
	while ( BusyADC());
	LUI_ResultatConversion = ReadADC();
	if (((uchar)DISTANCE_30CM_GAUCHE)< ((uchar) (LUI_ResultatConversion >>1)))
	{
		GUC_Capteur_Gauche =1;		// indique qu'il y a un mur devant.
	}
}
//********************************************************
//Fonction: OS_ConversionAN
//Utilisation: Fonction pour la conversion Analogique Mesure de distance
//Date: 20/11/2003
//Auteur: LG
//********************************************************
void OS_ConversionAN(void)
{
// Dclaration de variable locales 
uint LUI_ResultatConversion;
	LUI_ResultatConversion =0;
// Dbut du corps de la fonction
GUC_PoidsCellule =0;

OpenADC(ADC_FOSC_64 & ADC_5ANA_0REF & ADC_RIGHT_JUST, ADC_INT_OFF & ADC_CH0);
Delay100TCYx(1); // attente pour le condensateur
ConvertADC();  // lancement de la conversion sur le canal 0
while ( BusyADC());
LUI_ResultatConversion = ReadADC();
SetChanADC(ADC_CH1); // slection de le canal 1
Delay100TCYx(1); // attente pour le condensateur
ConvertADC();  // lancement de la conversion sur le canal 1
// calcul avec le canal 0
//LUI_ResultatConversion = LUI_ResultatConversion >>2; // masquage des bits de poids faible.
// recherche de la distance dans le tableau!
GUC_TAB_Distance[CAPTEUR_AVANT] = (uchar) (LUI_ResultatConversion >>1);
// calcul du poids de la cellule
	if ((((uchar) DISTANCE_70CM_AVANT )< GUC_TAB_Distance[CAPTEUR_AVANT])&&( GUC_TAB_Distance[CAPTEUR_AVANT]<((uchar)DISTANCE_50CM_AVANT)))
		GUC_PoidsCellule = GUC_PoidsCellule | MUR_A_1_CASE_AVANT;
	else
	{
		if (((uchar) DISTANCE_70CM_AVANT) > GUC_TAB_Distance[CAPTEUR_AVANT])
			GUC_PoidsCellule = GUC_PoidsCellule | MUR_AU_DELA_2_CASE_AVANT;
	}
while ( BusyADC());
LUI_ResultatConversion = ReadADC();
SetChanADC(ADC_CH2); // slection de le canal 2
Delay100TCYx(1); // attente pour le condensateur
ConvertADC();  // lancement de la conversion sur le canal 2
// calcul avec le canal 1
//LUI_ResultatConversion = LUI_ResultatConversion >>2; // masquage des bits de poids faible.
// recherche de la distance dans le tableau!
// sauvegarde
GUC_TAB_Distance[CAPTEUR_DROIT] = (uchar)(LUI_ResultatConversion >> 1);
// calcul du poids de la cellule

	if (( DISTANCE_70CM_DROIT < GUC_TAB_Distance[CAPTEUR_DROIT])&&(GUC_TAB_Distance[CAPTEUR_DROIT]<DISTANCE_50CM_DROIT))
		GUC_PoidsCellule = GUC_PoidsCellule | MUR_A_1_CASE_DROIT;
	else
	{
		if ( DISTANCE_70CM_DROIT >  GUC_TAB_Distance[CAPTEUR_DROIT])
			GUC_PoidsCellule = GUC_PoidsCellule | MUR_AU_DELA_2_CASE_DROIT;
	}
while ( BusyADC());
LUI_ResultatConversion = ReadADC();
SetChanADC(ADC_CH3); // slection de le canal 3
Delay100TCYx(1); // attente pour le condensateur
ConvertADC();  // lancement de la conversion sur le canal 3
// calcul avec le canal 2
//LUI_ResultatConversion = LUI_ResultatConversion >>2; // masquage des bits de poids faible.
// recherche de la distance dans le tableau!
// sauvegarde
GUC_TAB_Distance[CAPTEUR_ARRIERE] = (uchar)(LUI_ResultatConversion >> 1);
	if (( DISTANCE_70CM_ARRIERE < GUC_TAB_Distance[CAPTEUR_ARRIERE])&&(GUC_TAB_Distance[CAPTEUR_ARRIERE]<DISTANCE_50CM_ARRIERE))
		GUC_PoidsCellule = GUC_PoidsCellule | MUR_A_1_CASE_ARRIERE;
	else
	{
		if ( DISTANCE_70CM_ARRIERE >  GUC_TAB_Distance[CAPTEUR_ARRIERE])
			GUC_PoidsCellule = GUC_PoidsCellule | MUR_AU_DELA_2_CASE_ARRIERE;
	}
while ( BusyADC());
LUI_ResultatConversion = ReadADC();
//LUI_ResultatConversion = LUI_ResultatConversion >>2; // masquage des bits de poids faible.
// recherche de la distance dans le tableau!
// sauvegarde
GUC_TAB_Distance[CAPTEUR_GAUCHE]= (uchar)(LUI_ResultatConversion >> 1);
	if (( DISTANCE_70CM_GAUCHE < GUC_TAB_Distance[CAPTEUR_GAUCHE])&&(GUC_TAB_Distance[CAPTEUR_GAUCHE]<DISTANCE_50CM_GAUCHE))
		GUC_PoidsCellule = GUC_PoidsCellule | MUR_A_1_CASE_GAUCHE;
	else
	{
		if ( DISTANCE_70CM_GAUCHE >  GUC_TAB_Distance[CAPTEUR_GAUCHE])
			GUC_PoidsCellule = GUC_PoidsCellule | MUR_AU_DELA_2_CASE_GAUCHE;
	}
CloseADC(); //arrete le convertisseur.
}
/********************************************************
Fonction: OS_MesureAccelerationStatique
Utilisation: Fonction de mesure de l'acclration statique  l'arrt
Date: 04/04/2004
Auteur: LG
********************************************************/
void OS_MesureAccelerationStatique(void)
{
	// dclaration de variable locale
	uchar LUC_CounterLoop;
	LUC_CounterLoop=0;
	// utilisation des variables globales!
	
	GSL_Acceleration = 0;
	GSL_AccelerationStatiqueX=0;
	GSL_AccelerationStatiqueY=0;
	// pour la mthode de mesure se reporter  la note d'application d'analog device:AN-604
	// pour un dmarrage en phase on boucle tant que le signal sur RB7 n'est pas nul.
	// mesure de l'acclration statique afin de la soustraire  
	for(LUC_CounterLoop=0;LUC_CounterLoop<4;LUC_CounterLoop++)
	{
		OS_MesureAcceleration();	// lancement d'une mesure d'acceleration sur X et Y	
		
	GSL_AccelerationStatiqueX = GSL_AccelerationX + GSL_AccelerationStatiqueX;
	GSL_AccelerationStatiqueY = GSL_AccelerationY + GSL_AccelerationStatiqueY;
	}
	
	if (GSL_AccelerationStatiqueX >=0)
			GSL_AccelerationStatiqueX = GSL_AccelerationStatiqueX >> 2;
		else
			GSL_AccelerationStatiqueX =-((-GSL_AccelerationStatiqueX) >>2);
	if (GSL_AccelerationStatiqueY >=0)
			GSL_AccelerationStatiqueY = GSL_AccelerationStatiqueY >> 2;
		else
			GSL_AccelerationStatiqueY =-((-GSL_AccelerationStatiqueY) >>2);
	
}
/********************************************************
Fonction: OS_MesureAcceleration
Utilisation:Fonction pour la mesure d'acceleration
Date: 12/03/2004
Auteur: LG
********************************************************/
void OS_MesureAcceleration(void)
{
	// dclaration de variables locales
	
	// dbut du corps de la fonction 
	//	Le rsultat  est mis dans deux variables globales GSL_AccelerationX et GSL_AccelerationY
	// pour la mthode de mesure se reporter  la note d'application d'analog device:AN-604
	// pour un dmarrage en phase on boucle tant que le signal sur RB7 n'est pas nul.
	// finalement on utilise le timer 3 car il ne bloque pas les entres sorties RC1 et RC0!
	GUI_TempsT1X = 0;
	GUI_TempsT1Y = 0;
	GUI_TempsTb = 0;
	GUI_TempsTc = 0;
	GUI_TempsTd = 0;
	GUI_TempsT2 = 0;
	
	while(PORTBbits.RB7 ==1); // on attend de se caler par rapport au T1X =0 pour dtecter le front montant et s'affranchir de Ta!

	// on perd potentiellement 0.5ms!
//	GUC_EtatAccelerometre =0;// on va attendre le Ta!
	// on va faire une mesure de l'accleration statique en X.	
//	while (GUC_EtatAccelerometre !=4);	// attente de la fin d'une mesure 
	
	// nouveau code	
	while(PORTBbits.RB7 ==0); // on attend le front montant sur X
	TMR3H =0;
	TMR3L =0; // c'est  ce moment que c'est vraiement crit
	while(PORTBbits.RB7 ==1);// on attend le front descendant.
	GUI_TempsTb = TMR3L;
	GUI_TempsTb += ((uint)TMR3H)<<8;
	while(PORTBbits.RB6 ==1);	// on attend que Y repasse  0
	while(PORTBbits.RB6 ==0);	// on attend le front montant sur Y
	GUI_TempsTc = TMR3L;
	GUI_TempsTc += ((uint)TMR3H)<<8;
	while(PORTBbits.RB6 ==1);// on attend le front descendant.
	GUI_TempsTd = TMR3L;
	GUI_TempsTd += ((uint)TMR3H)<<8;
	// on a la mesure de tous les temps necessaire au calcul.
	// fin nouveau code
	
	// le temps d'une mesure est de environ 2ms, tant donn le choix des R=125kohm et CX, CY de l'acclrometre.
	GUI_TempsT1X = GUI_TempsTb; // puisqu'on a suppos qu'on demmarre  Ta=0
	GUI_TempsT1Y = GUI_TempsTd-GUI_TempsTc;		
	GUI_TempsT2 = (GUI_TempsTd -(GUI_TempsT1Y >>1))- (GUI_TempsTb >> 1);
	// calcul de l'acceleration sur X
	GSL_AccelerationX = (((short long)GUI_TempsT1X*(short long)1000  )/ (short long)GUI_TempsT2) - (short long)500;
	if (GSL_AccelerationX >=0)
		GSL_AccelerationX = GSL_AccelerationX << 3;
	else
		GSL_AccelerationX =-((-GSL_AccelerationX) <<3);
	// calcule de l'acceleration sur Y
	
	GSL_AccelerationY = (((short long)GUI_TempsT1Y*(short long)1000  )/ (short long)GUI_TempsT2) - (short long)500;
	if (GSL_AccelerationY >=0)
		GSL_AccelerationY = GSL_AccelerationY << 3;
	else
		GSL_AccelerationY =-((-GSL_AccelerationY) <<3);
	
}// fin de la fonction de calcul d'acceleration.


////////////////////////////////////////////////////////////////////////
////                          OS_Moteur.c	                        ////
////                                                                ////
////  Define utilis par les fonctions de gestion du moteur			////
////                 18F242 quartz 20 MHz ou 10Mhz *4 (PLL) = 40Mhz ////
////  Auteur: 	LG					     							////
////  Date:	 22 mars 2004                                     		////
////                                                                ////
////////////////////////////////////////////////////////////////////////
////        (C) Copyright 2004 - LG				             		////
////								     							////
////////////////////////////////////////////////////////////////////////

/********************************************************
Fonction: OS_Avancer
Utilisation: Fonction grer l'avancement sur une distance de X cm
Date: 22/03/2004
Auteur: LG
********************************************************/
void OS_Avancer(short long LSL_Distance)
{	// le parametre d'entre donne la distance en m, ce qui fait que 150000 correspond  15cm par exemple
	// dclaration de variable locale
//	uchar LUC_CounterLoop;

	// dclaration du corps de la fonction
	GSL_DistanceX =0;
	GSL_VitessePrecedenteX =0;
	GSL_VitesseX =0;
//	LUC_CounterLoop=0;
	i=0;	// initialisation du compteur de boucle d'asservissement.
	GUC_Avancement =0;
	OS_MoteurAvancer();

/*	OS_Lcd_Clear();
	OS_Lcd_Char('_');
	OS_Lcd_Char('A');
	OS_Lcd_Char(i+'0');
	OS_Lcd_Char(GUC_Poids_Cellule+'0');
	OS_ClignotementLed400ms(5);	// clignotement pendant 0.4s	
*/
//	while(GSL_DistanceX <LSL_Distance )
	while(GUC_Avancement < LSL_Distance)
	{	// attente d'une synchro sur le 20ms.
//		OS_MoteurAvancer(); // on remet les moteurs en avant!
		while (GUI_Timing20ms != TIMING_20MS);	// indique qu'on par pour une boucle de 20ms, et donc a le temps de faire 4 mesures
/*		GSL_Acceleration = 0;		
		for(LUC_CounterLoop=0;LUC_CounterLoop<4;LUC_CounterLoop++)
		{
			// lancement d'une mesure
			OS_MesureAcceleration();	// lancement d'une mesure d'acceleration sur X et Y	
			GSL_Acceleration = GSL_Acceleration + (GSL_AccelerationX - GSL_AccelerationStatiqueX);
		}
		// on doit diviser le rsultat par 4!
		if (GSL_Acceleration >=0)
			GSL_Acceleration = GSL_Acceleration >> 2;
		else
			GSL_Acceleration =-((-GSL_Acceleration) >>2);
	// Calcul de la vitesse
	// V(t)= V(t-1)+A(t)*dt
	// Calcul de la distance:
	// D(t)=D(t-1)+V(t-1)*dt + (A(t)*dt)/2
		//Sl_Vitesse = SL_VitessePrecedente +SL_Acceleration*196; 
		GSL_VitesseX = GSL_Acceleration*196; // calcul intermdiare
		GSL_DistanceX = GSL_DistanceX + (GSL_VitessePrecedenteX*2 + GSL_VitesseX)/100; 
		GSL_VitessePrecedenteX = GSL_VitesseX + GSL_VitessePrecedenteX;	// sauvegarde
*/		
		// recalage si necessaire
//		i++;	// incrmentation du compteur de boucle!
		OS_ConversionAN();	// lancement d'une conversion sur les capteurs sharp.
		if (GUC_TAB_Distance[CAPTEUR_AVANT] > (DISTANCE_20CM_AVANT - 36))
		{
			OS_MoteurArret();	// on arrete le moteur.
			GSL_DistanceX = LSL_Distance +1;	// pour sortir de la boucle while
			GUC_Avancement = 120;
		}
		else
		{	// recalage sur les cots!
			if( GUC_Recalage == 1)
			{
			// On va en fait se baser sur une comparaison entre les mesures des capteurs sharp des cot.
//			if((GUC_Avancement == 20)||(GUC_Avancement == 40)||(GUC_Avancement == 41)||(GUC_Avancement == 42)||(GUC_Avancement == 60)||(GUC_Avancement == 61)||(GUC_Avancement == 62)||(GUC_Avancement == 80)||(GUC_Avancement == 81)||(GUC_Avancement == 82))
			if((GUC_Avancement == 0)||(GUC_Avancement == 20)||(GUC_Avancement == 21)||(GUC_Avancement == 60)||(GUC_Avancement == 61))
			{
				if((GUC_TAB_Distance[CAPTEUR_GAUCHE] >= DISTANCE_30CM_GAUCHE)&& (GUC_TAB_Distance[CAPTEUR_DROIT] >= DISTANCE_30CM_DROIT))		// On test pour savoir si on a un mur  droite et  gauche
				{
					if(GUC_TAB_Distance[CAPTEUR_GAUCHE]-6 < GUC_TAB_Distance[CAPTEUR_DROIT])
					{	// on tourne  gauche
						OS_MoteurGauche();
						OS_Lcd_Clear();
						OS_Lcd_Char('5');
						while (GUI_Timing20ms != TIMING_1MS);
						while (GUI_Timing20ms != TIMING_20MS);
						while (GUI_Timing20ms != TIMING_1MS);
						while (GUI_Timing20ms != TIMING_20MS);	
						OS_MoteurAvancer();	// on remet le moteur.
					}
					else
					{
						if(GUC_TAB_Distance[CAPTEUR_GAUCHE]-10 > GUC_TAB_Distance[CAPTEUR_DROIT])
						{	// on tourne  droite
							OS_MoteurDroite();
							OS_Lcd_Clear();
							OS_Lcd_Char('6' );
							while (GUI_Timing20ms != TIMING_1MS);
							while (GUI_Timing20ms != TIMING_20MS);
//1							while (GUI_Timing20ms != TIMING_1MS);
//1							while (GUI_Timing20ms != TIMING_20MS);	
	
							OS_MoteurAvancer();	// on remet le moteur.
						}
					}
				}  
				else
				{	// on a un mur  droite
					if(GUC_TAB_Distance[CAPTEUR_DROIT] >= DISTANCE_30CM_DROIT)		// Attention en fait cela revient  tester si on a un mur  moins de 30cm
					{ // recalage droit
						if(GUC_TAB_Distance[CAPTEUR_DROIT] <= (DISTANCE_20CM_DROIT-3))		// Attention en fait cela revient  tester si on est  +20cm du mur droit
						{
							OS_MoteurDroite();
							OS_Lcd_Clear();
							OS_Lcd_Char('1');
							while (GUI_Timing20ms != TIMING_1MS);
							while (GUI_Timing20ms != TIMING_20MS);
					//		while (GUI_Timing20ms != TIMING_1MS);
					//		while (GUI_Timing20ms != TIMING_20MS);	
	
							OS_MoteurAvancer();	// on remet le moteur.
						}
						else
						{
							if(GUC_TAB_Distance[CAPTEUR_DROIT] >= (DISTANCE_20CM_DROIT+3))		// Attention en fait cela revient  tester si on est  - de 20cm du mur droit
							{	
								OS_MoteurGauche();
								OS_Lcd_Clear();
								OS_Lcd_Char('2');
								while (GUI_Timing20ms != TIMING_1MS);
								while (GUI_Timing20ms != TIMING_20MS);	
//1								while (GUI_Timing20ms != TIMING_1MS);
//1								while (GUI_Timing20ms != TIMING_20MS);	
								OS_MoteurAvancer();	// on remet le moteur.
							}
						}
					}	
					else
					{	// on a un mur  gauche
						if(GUC_TAB_Distance[CAPTEUR_GAUCHE] >= DISTANCE_30CM_GAUCHE)		// Attention en fait cela revient  tester si on a un mur  moins de 30cm
						{ // recalage gauche
							if(GUC_TAB_Distance[CAPTEUR_GAUCHE] <= (DISTANCE_20CM_GAUCHE-3)) 		// Attention en fait cela revient  tester si on est  +20cm du mur droit
							{	
								OS_MoteurGauche();
								OS_Lcd_Clear();
								OS_Lcd_Char(' ' );
								OS_Lcd_Char(' ' );
								OS_Lcd_Char('3');
								while (GUI_Timing20ms != TIMING_1MS);
								while (GUI_Timing20ms != TIMING_20MS);	
						//		while (GUI_Timing20ms != TIMING_1MS);
						//		while (GUI_Timing20ms != TIMING_20MS);	
								OS_MoteurAvancer();	// on remet le moteur.
							}
							else
							{
								if(GUC_TAB_Distance[CAPTEUR_GAUCHE] >= (DISTANCE_20CM_GAUCHE+3))		// Attention en fait cela revient  tester si on est  +20cm du mur droit
								{	//	OS_MoteurArret();	// on arrete le moteur.
									OS_MoteurDroite();
									while (GUI_Timing20ms != TIMING_1MS);
									while (GUI_Timing20ms != TIMING_20MS);	
//									while (GUI_Timing20ms != TIMING_1MS);
//									while (GUI_Timing20ms != TIMING_20MS);	

									OS_Lcd_Clear();
									OS_Lcd_Char('4' );
//									OS_Lcd_Hexa(GUC_TAB_Distance[CAPTEUR_GAUCHE]);
//									while (1);
									OS_MoteurAvancer();	// on remet le moteur.
								}
							}
						}
					// sinon on a aucun mur  droite et  gauche
					}
				}			
			}
			}
		}
	} 
	GUC_Avancement =0;
	OS_MoteurGauche();
	while(GUC_Avancement <9)
	{	while (GUI_Timing20ms != TIMING_1MS);	// indique qu'on par pour une boucle de 20ms, et donc a le temps de faire 4 mesures
		
	}
	OS_MoteurArret();	// on arrete le moteur.
	GUC_Avancement =0;

}
/********************************************************
Fonction: OS_Reculer
Utilisation: Fonction grer l'avancement sur une distance de X cm
Date: 22/03/2004
Auteur: LG
********************************************************/
void OS_Reculer(short long LSL_Distance)
{
	// dclaration de variable locale
	uchar LUC_CounterLoop =0;
	// dclaration du corps de la fonction
	GSL_DistanceX =0;
	GSL_VitessePrecedenteX =0;
	GSL_VitesseX =0;


	OS_MoteurArriere();
	while(GSL_DistanceX >LSL_Distance )
	{	// attente d'une synchro sur le 20ms.
		while (GUI_Timing20ms != TIMING_1MS);	// indique qu'on par pour une boucle de 20ms, et donc a le temps de faire 4 mesures
		GSL_Acceleration = 0;		
		for(LUC_CounterLoop=0;LUC_CounterLoop<4;LUC_CounterLoop++)
		{
			// lancement d'une mesure
			OS_MesureAcceleration();	// lancement d'une mesure d'acceleration sur X et Y	
			GSL_Acceleration = GSL_Acceleration + (GSL_AccelerationX - GSL_AccelerationStatiqueX);
		}
		// on doit diviser le rsultat par 4!
		if (GSL_Acceleration >=0)
			GSL_Acceleration = GSL_Acceleration >> 2;
		else
			GSL_Acceleration =-((-GSL_Acceleration) >>2);
	// Calcul de la vitesse
	// V(t)= V(t-1)+A(t)*dt
	// Calcul de la distance:
	// D(t)=D(t-1)+V(t-1)*dt + (A(t)*dt)/2
		//Sl_Vitesse = SL_VitessePrecedente +SL_Acceleration*196; 
		GSL_VitesseX = GSL_Acceleration*196; // calcul intermdiare
		GSL_DistanceX = GSL_DistanceX + (GSL_VitessePrecedenteX*2 + GSL_VitesseX)/100; 
		GSL_VitessePrecedenteX = GSL_VitesseX + GSL_VitessePrecedenteX;	// sauvegarde
		// recalage si necessaire
		OS_ConversionAN();	// lancement d'une conversion sur les capteurs sharp.
		if (GUC_TAB_Distance[CAPTEUR_ARRIERE] > DISTANCE_20CM_AVANT)
		{
			OS_MoteurArret();	// on arrete le moteur.
			GSL_DistanceX = LSL_Distance -1;	// pour sortir de la boucle while
		}
		//To do recalage sur les cots!
	} 
	OS_MoteurArret();	// on arrete le moteur.
}
/********************************************************
Fonction: OS_TournerDroite
Utilisation: Fonction grer la rotation de X sur la droite
Date: 22/03/2004
Auteur: LG
********************************************************/
void OS_TournerDroite(short long LSL_Distance)
{	// la valeur pass en parametre doit etre ngative et doit etre en m.
	// dclaration de variable locale
	uchar LUC_CounterLoop;
	LUC_CounterLoop=0;
	// dclaration du corps de la fonction

	// dclaration du corps de la fonction
	GSL_DistanceY =0;
	GSL_VitessePrecedenteY =0;
	GSL_VitesseY =0;
	

	OS_MoteurDroite();
	while(GSL_DistanceY > LSL_Distance )
	{	// attente d'une synchro sur le 20ms.
		while (GUI_Timing20ms != TIMING_1MS);	// indique qu'on par pour une boucle de 20ms, et donc a le temps de faire 4 mesures
		GSL_Acceleration = 0;	
		for(LUC_CounterLoop=0;LUC_CounterLoop<4;LUC_CounterLoop++)
		{
			// lancement d'une mesure
			OS_MesureAcceleration();	// lancement d'une mesure d'acceleration sur X et Y	
			GSL_Acceleration = GSL_Acceleration + (GSL_AccelerationY - GSL_AccelerationStatiqueY);
		}
		// on doit diviser le rsultat par 4!
		if (GSL_Acceleration >=0)
			GSL_Acceleration = GSL_Acceleration >> 2;
		else
			GSL_Acceleration =-((-GSL_Acceleration) >>2);
	// Calcul de la vitesse
	// V(t)= V(t-1)+A(t)*dt
	// Calcul de la distance:
	// D(t)=D(t-1)+V(t-1)*dt + (A(t)*dt)/2
		//Sl_Vitesse = SL_VitessePrecedente +SL_Acceleration*196; 
		GSL_VitesseY = GSL_Acceleration*196; // calcul intermdiare
		GSL_DistanceY = GSL_DistanceY + (GSL_VitessePrecedenteY*2 + GSL_VitesseY)/100; 
		GSL_VitessePrecedenteY = GSL_VitesseY + GSL_VitessePrecedenteY;	// sauvegarde
	} 
	OS_MoteurArret();	// on arrete le moteur.
	
}
/********************************************************
Fonction: OS_TournerGauche
Utilisation: Fonction grer la rotation de X sur la gauche
Date: 22/03/2004
Auteur: LG
********************************************************/
void OS_TournerGauche(short long LSL_Distance)
{	// la valeur passe doit tre positive et en m
	// dclaration de variable locale
	uchar LUC_CounterLoop;
	LUC_CounterLoop=0;
	// dclaration du corps de la fonction
	GSL_DistanceY =0;
	GSL_VitessePrecedenteY =0;
	GSL_VitesseY =0;
	

	OS_MoteurGauche();
	while(GSL_DistanceY < LSL_Distance )
	{	// attente d'une synchro sur le 20ms.
		while (GUI_Timing20ms != TIMING_1MS);	// indique qu'on par pour une boucle de 20ms, et donc a le temps de faire 4 mesures
		GSL_Acceleration = 0;	
		for(LUC_CounterLoop=0;LUC_CounterLoop<4;LUC_CounterLoop++)
		{
			// lancement d'une mesure
			OS_MesureAcceleration();	// lancement d'une mesure d'acceleration sur X et Y	
			GSL_Acceleration = GSL_Acceleration + (GSL_AccelerationY - GSL_AccelerationStatiqueY);
		}
		// on doit diviser le rsultat par 4!
		if (GSL_Acceleration >=0)
			GSL_Acceleration = GSL_Acceleration >> 2;
		else
			GSL_Acceleration =-((-GSL_Acceleration) >>2);
	// Calcul de la vitesse
	// V(t)= V(t-1)+A(t)*dt
	// Calcul de la distance:
	// D(t)=D(t-1)+V(t-1)*dt + (A(t)*dt)/2
		//Sl_Vitesse = SL_VitessePrecedente +SL_Acceleration*196; 
		GSL_VitesseY = GSL_Acceleration*196; // calcul intermdiare
		GSL_DistanceY = GSL_DistanceY + (GSL_VitessePrecedenteY*2 + GSL_VitesseY)/100; 
		GSL_VitessePrecedenteY = GSL_VitesseY + GSL_VitessePrecedenteY;	// sauvegarde
	} 
	OS_MoteurArret();	// on arrete le moteur.

	
}
//********************************************************
//Fonction: OS_MoteurAvancer
//Utilisation: Fonction pour la gestion des moteurs. Faire avancer le robot
//Date: 12/03/2004
//Auteur: LG
//********************************************************
void OS_MoteurAvancer(void)
{
	// dclaration de variable locale
	
	// dclaration du corps de la fonction
	GUC_MoteurDroit = MOTEUR_DROIT_AVANT;
	GUC_MoteurGauche = MOTEUR_GAUCHE_AVANT;
	
}//fin de OS_MoteurAvancer

//********************************************************
//Fonction: OS_MoteurReculer
//Utilisation: Fonction pour la gestion des moteurs. Faire reculer le robot
//Date: 12/03/2004
//Auteur: LG
//********************************************************
void OS_MoteurArriere(void)
{
	// dclaration de variable locale
	
	// dclaration du corps de la fonction
	GUC_MoteurDroit = MOTEUR_DROIT_ARRIERE;
	GUC_MoteurGauche = MOTEUR_GAUCHE_ARRIERE;
	
}//fin de OS_MoteurReculer
//********************************************************
//Fonction: OS_MoteurGauche
//Utilisation: Fonction pour la gestion des moteurs. Faire tourner  gauche
//Date: 12/03/2004
//Auteur: LG
//********************************************************
void OS_MoteurGauche(void)
{
	// dclaration de variable locale
	
	// dclaration du corps de la fonction
	GUC_MoteurDroit = MOTEUR_DROIT_AVANT;
	GUC_MoteurGauche = MOTEUR_GAUCHE_ARRET;
}
//********************************************************
//Fonction: OS_MoteurDroit
//Utilisation: Fonction pour la gestion des moteurs. Faire tourner  droite
//Date: 12/03/2004
//Auteur: LG
//********************************************************
void OS_MoteurDroite(void)
{
	// dclaration de variable locale
	
	// dclaration du corps de la fonction
	GUC_MoteurDroit = MOTEUR_DROIT_ARRET;
	GUC_MoteurGauche = MOTEUR_GAUCHE_AVANT;
}




//********************************************************
//Fonction: OS_MoteurArret
//Utilisation: Fonction pour la gestion des moteurs. Arreter les moteurs
//Date: 19/03/2004
//Auteur: LG
//********************************************************
void  OS_MoteurArret(void)
{
	// dclaration de variable locale
	GUC_MoteurDroit = MOTEUR_DROIT_ARRET;
	GUC_MoteurGauche = MOTEUR_GAUCHE_ARRET;
		
	
}





////////////////////////////////////////////////////////////////////////
////                          OS_Lcd.c		                        ////
////                                                                ////
////  Fonction grant l'cran LCD			 						////
////                 18F242 quartz 20 MHz ou 10Mhz *4 (PLL) = 40Mhz ////
////  Auteur: 	LG					     							////
////  Date:	 15 novembre 2003                                     	////
////                                                                ////
////////////////////////////////////////////////////////////////////////
////        (C) Copyright 2003 - LG				             		////
////								     							////
////////////////////////////////////////////////////////////////////////

// 20x4 module
   //  Line 1 addresses are 00h to 13h
   //  Line 2 addresses are 40h to 53h
   //  Line 3 addresses are 14h to 27h
   //  Line 4 addresses are 54h to 67h

// 16*2 module
	// Ligne 1 addresses de 00h  0Fh
	// Ligne 2 addresses de 40h	 4Fh

// Pour information le cablage suivant pour un fonctionnement en mode 4 bits
// RB0 D0
// RB1 D1
// RB2 D2
// RB3 D3
// RB4 E
// RB5 RS
// R/W est forc  la masse, donc on ne peut pas lire sur l'cran.




/********************************************************
Fonction: OS_IniLcd
Utilisation: Fonction d'initialisation de l'afficheur LCD
Date: 23/11/2003
Auteur: LG
********************************************************/

void OS_InitLcd(void)
{
	// dclaration de variables locales
	uchar LUC_VarSend;
	LUC_VarSend=0;
	// dbut du corps de la fonction 
	// boucle de tempo de 15ms nessaire au boot!
	Delay1KTCYx(75);		//15ms 75000 * 200ns
	
	 // System Set
	LUC_VarSend= 0x03; 							// Mode 8 bit 
	OS_Lcd_Send(LUC_VarSend);						// poids fort
	OS_Lcd_Send(LUC_VarSend);						// poids fort
	OS_Lcd_Send(LUC_VarSend);						// poids fort

//	LUC_VarSend= 0x02;							// mode 4 bit
//	OS_Lcd_Send(LUC_VarSend);						// poids fort

	// System Set
	LUC_VarSend= 0x03; 							// Mode 4 bit 
	OS_Lcd_Send(LUC_VarSend);						// poids fort
	LUC_VarSend= 0x02;							// 1 Lignes
	OS_Lcd_Send(LUC_VarSend);						// poids faible commande
				// Set ON/OFF
	LUC_VarSend= 0x00; 							// display On, curseur On, Blink On
	OS_Lcd_Send(LUC_VarSend);
	LUC_VarSend = 0x0E;							// poids faible ecran On, Cursor On, Blink OFF
	OS_Lcd_Send(LUC_VarSend);	
	Delay10KTCYx(1);						// delais de 2ms pour un quartz de 20Mhz
	OS_Lcd_Clear();
				// Set entry mode
	LUC_VarSend = 0x00;
	OS_Lcd_Send(LUC_VarSend);
	LUC_VarSend = 0x06;							// poids faible
	OS_Lcd_Send(LUC_VarSend);
	OS_Lcd_Clear();
	Delay10KTCYx(1);						// delais de 2ms pour un quartz de 20Mhz
}

/********************************************************
Fonction: OS_Lcd_Ligne
Utilisation: Fonction de selection de ligne
Date: 23/11/2003
Auteur: LG
********************************************************/
void OS_Lcd_Line( uchar LUC_Ligne)
{
	// dclaration de variables locales
	
	// dbut du corps de la fonction 
	
// positionnement sur la ligne X.
/* cran 4 ligne 20 characteres
	if (LUC_Ligne == 1) LUC_Ligne= 0x80;
	if (LUC_Ligne == 2) LUC_Ligne =0xC0;							// poids fort ligne 2
	if (LUC_Ligne == 3) LUC_Ligne =0x90;							// poids fort ligne 3
	if (LUC_Ligne == 4) LUC_Ligne=0xD0;							// poids fort ligne 4
*/
// cran 2 lignes 16 characteres:
	if (LUC_Ligne == 1) LUC_Ligne= 0x00;							// poids fort ligne 1
	if (LUC_Ligne == 2) LUC_Ligne =0x0C;							// poids fort ligne 2
	
	OS_Lcd_Send(LUC_Ligne);
/* cran 4 lignes 
	if ((LUC_Ligne ==0x80) ||(LUC_Ligne == 0xC0))
		LUC_Ligne=0x00;							// poids faible ligne 1 et 2
	else
		LUC_Ligne = 0x40;				// poids faible ligne 3 et 4
	*/
	LUC_Ligne = 0x00;		// cran 2 lignes 16 characteres. poids faible
	OS_Lcd_Send(LUC_Ligne);
}

/********************************************************
Fonction: OS_Lcd_Send_noWait
Utilisation: Focntion d'envoi d'une commande  l'cran
Date: 23/11/2003
Auteur: LG
********************************************************/
void OS_Lcd_Send_noWait(uchar LUC_VarSend)
{
	// dclaration de variables locales
	// dbut du corps de la fonction 
											// Envoi de caractere sans tempo
	PORTB= LUC_VarSend;  					/* masquage des poids faible*/
	Delay1TCY();			//quivalent  1 nop
	PORTBbits.RB4=1;		// mise  1 de E ( validation)
	//bit_set(LCD_DATA_PORT,2); 					/* mise  1 de E (validation)*/
	Delay1TCY();			//quivalent  1 nop
	Delay1TCY();			//quivalent  1 nop
	Delay1TCY();			//quivalent  1 nop
	PORTBbits.RB4 =0;		//mise  0 du bit E
	//bit_clear(LCD_DATA_PORT,2);					/* mise  0 de E*/
}
/********************************************************
Fonction: OS_Lcd_Send
Utilisation: Fonction d'envoi de commande  l'cran
Date: 23/11/2003
Auteur: LG
********************************************************/
void OS_Lcd_Send(uchar LUC_VarSend)
{									// input LUC_VarSend => contient l octect de command  envoyer.
	OS_Lcd_Send_noWait(LUC_VarSend);
									// envoi d un octets sur l ecran de l afficheur LCD
	Delay100TCYx(2);				//attente de 40us mini pour une commande cf doc
									// envoi des poids faible  l ecran
}

/********************************************************
Fonction: OS_Lcd_Clear
Utilisation: Fonction d'effacement de l'cran
Date: 23/11/2003
Auteur: LG
********************************************************/
void OS_Lcd_Clear(void)
{
	// dclaration de variables locales
	uchar LUC_VarToSend;
	LUC_VarToSend=0;
	// dbut du corps de la fonction 

	// cmd=0x01;
	// envoi poids fort
	OS_Lcd_Send(LUC_VarToSend);						// appel de la fonction d envoi de commande
	LUC_VarToSend= 0x01;						// envoi poids faible
	OS_Lcd_Send(LUC_VarToSend);
	Delay10KTCYx(1);	//attente de 2ms
}
/********************************************************
Fonction: OS_Lcd_Char
Utilisation: Fonction d'affichage d'un charactere  l'cran
Date: 23/11/2003
Auteur: LG
********************************************************/
void OS_Lcd_Char(uchar LUC_CharSend)
{									// envoi d un charactere  l cran
	// les donnes sont sur les bit RB0- RB3 du port B, le RB4 = E, RB5 = RS
	// dclaration de variables locales
	uchar LUC_VarToSend;							// variable interne  la fonction
	LUC_VarToSend=0;
	// dbut du corps de la fonction 
	LUC_VarToSend= LUC_CharSend >> 4;					// masquage des poids faible ! 
	LUC_VarToSend= LUC_VarToSend +0x20; 					// RS =1 ( RB5)
	PORTB= LUC_VarToSend;  					// masquage des poids faible
	Delay1TCY();			//quivalent  1 nop
	PORTBbits.RB4 = 1;			// mise  1 de E ( validation)
//	bit_set(LCD_DATA_PORT,2); 					// mise  1 de E (validation)
	Delay1TCY();			//quivalent  1 nop
	Delay1TCY();			//quivalent  1 nop
	Delay1TCY();			//quivalent  1 nop
	PORTBbits.RB4 = 0;
//	bit_clear(LCD_DATA_PORT,2);					// mise  0 de E

	LUC_VarToSend = LUC_CharSend & 0x0F;					// masquage des poids forts
	LUC_VarToSend = LUC_VarToSend + 0x20;					// position de RS=1 ( RB5 = 1)
	PORTB= LUC_VarToSend;	  				// masquage des poids faible
	Delay1TCY();			//quivalent  1 nop
	PORTBbits.RB4 = 1;
//	bit_set(LCD_DATA_PORT,2); 					// mise  1 de E (validation)
	Delay1TCY();			//quivalent  1 nop
	Delay1TCY();			//quivalent  1 nop
	Delay1TCY();			//quivalent  1 nop
	PORTBbits.RB4 =0 ;
//	bit_clear(LCD_DATA_PORT,2);					// mise  0 de E
	Delay100TCYx(3);						// attente de 60s ncessaire pour l'cran, initialement 50s
	
}
/********************************************************
Fonction: OS_ReturnHome
Utilisation: Fonction de positionnement du curseur en haut  gauche
Date: 23/11/2003
Auteur: LG
********************************************************/
void OS_Lcd_ReturnHome(void)
{
	// dclaration de variables locales
	uchar LUC_VarSend;
	LUC_VarSend=0;
	// dbut du corps de la fonction 
	LUC_VarSend= 0x00;
	OS_Lcd_Send(LUC_VarSend);
	LUC_VarSend= 0x02;					// poids faible en mode 4 bits
	OS_Lcd_Send(LUC_VarSend);
	//boucle d'attente 1.64ms
	Delay100TCYx(82);
}

/********************************************************
Fonction: OS_LcdPrint
Utilisation: Fonction d'affichage d'une chaine de caractere
Date: 23/11/2003
Auteur: LG
********************************************************/
void OS_Lcd_Printf(uchar *LUC_PTR_Chaine)
{
	// dbut du corps de la fonction 
	// affichage d une chaine  l ecran du LCD.
	while(*LUC_PTR_Chaine != '\0')						// Affichage tant qu on est pas  la fin de la chaine
		{ 
		OS_Lcd_Char(*LUC_PTR_Chaine++);
		}
}
/********************************************************
Fonction: OS_Lcd_Cur_S_Right
Utilisation: Fonction de dcalage du curseur sur la droite
Date: 23/11/2003
Auteur: LG
********************************************************/
void OS_Lcd_Cur_S_Right(void)
{
	// dclaration de variables locales
	uchar LUC_VarSend;								// Valeur pour shift droit 0x14
	// dbut du corps de la fonction 
	LUC_VarSend= 0x01;	
	OS_Lcd_Send(LUC_VarSend);
	LUC_VarSend= 0x04;
	OS_Lcd_Send(LUC_VarSend);
}
/********************************************************
Fonction: OS_Lcd_Cur_S_Left
Utilisation: Fonction de dcalage du curseur sur la gauche
Date: 23/11/2003
Auteur: LG
********************************************************/
void OS_Lcd_Cur_S_Left()
{
	// dclaration de variables locales
	uchar LUC_VarSend;								// Valeur pour shift gauche 0x10
	// dbut du corps de la fonction 
	LUC_VarSend= 0x01;	
	OS_Lcd_Send(LUC_VarSend);
	LUC_VarSend= 0x00;
	OS_Lcd_Send(LUC_VarSend);
}
/********************************************************
Fonction: OS_Lcd_Line_MoitieGauche
Utilisation: Fonction pour se positionner sur la partie gauche de l'afficheur 1*16
Date: 12/12/2003
Auteur: LG
********************************************************/
void OS_Lcd_Line_MoitieGauche(void)
{
	// dclaration de variables locales

	// dbut du corps de la fonction 

	OS_Lcd_Send(0x08);
	OS_Lcd_Send(0x00);
}
/********************************************************
Fonction: OS_Lcd_Line_MoitieDroite
Utilisation: Fonction pour se positionner sur la partie droite de l'afficheur 1*16
Date: 12/12/2003
Auteur: LG
********************************************************/
void OS_Lcd_Line_MoitieDroite(void)
{
	// dclaration de variables locales

	// dbut du corps de la fonction 

	OS_Lcd_Send(0x08);
	OS_Lcd_Send(0x00);
}

/********************************************************
Fonction: OS_LcdHexa
Utilisation: Fonction d'affichage de donne au format hexa pour un char
Date: 23/11/2003
Auteur: LG
********************************************************/
void OS_Lcd_Hexa(uchar LUC_VarSend)
{
	// affiche  l ecran la valeur Hexa du nombre
	// dclaration de variables locales
	uchar LUC_VarToSend;								// variable temporaire
	// dbut du corps de la fonction 
	OS_Lcd_Char(0x30);								// affichage de 0x...
	OS_Lcd_Char(0x78);
	if ((LUC_VarSend>>4) > 9) 
		LUC_VarToSend= 0x37+(LUC_VarSend>>4);			// envoi quartet poids fort
	else
		LUC_VarToSend= 0x30+(LUC_VarSend>>4);
	OS_Lcd_Char(LUC_VarToSend);
	if ((LUC_VarSend & 0x0F) > 9)
		LUC_VarToSend= 0x37 +(LUC_VarSend & 0x0F);
	else
		LUC_VarToSend= 0x30+( LUC_VarSend  & 0x0F);					// envoi quartet poids faible
	OS_Lcd_Char(LUC_VarToSend);
}
/********************************************************
Fonction: OS_LcdHexaUint
Utilisation: Fonction d'affichage de donne au format hexa pour un integer non sign
Date: 05/12/2003
Auteur: LG
********************************************************/
void OS_Lcd_HexaUint(uint LUI_VarSend)
{
	// affiche  l ecran la valeur Hexa du nombre
	// dclaration de variables locales
	uchar LUC_VarToSend;								// variable temporaire
	// dbut du corps de la fonction 
	OS_Lcd_Char(0x30);								// affichage de 0x...
	OS_Lcd_Char(0x78);
	// afficher l'octet de poids fort!
	if (((LUI_VarSend>>8)>>4) > 9) 
		LUC_VarToSend= 0x37+((uchar)(LUI_VarSend>>8)>>4);			// envoi quartet poids fort
	else
		LUC_VarToSend= 0x30+(uchar)((LUI_VarSend>>8)>>4);
	OS_Lcd_Char(LUC_VarToSend);
	
	if (((LUI_VarSend>>8) & 0x0F) > 9)
		LUC_VarToSend= 0x37 +((uchar)(LUI_VarSend>>8) & 0x0F);
	else
		LUC_VarToSend= 0x30+((uchar)(LUI_VarSend>>8) & 0x0F);					// envoi quartet poids faible
	OS_Lcd_Char(LUC_VarToSend);
	
	//affichage de l'octet de poids faible
		if((((uchar)LUI_VarSend) >>4 ) > 9) 
		LUC_VarToSend= 0x37+(((uchar)LUI_VarSend)>>4);			// envoi quartet poids fort
	else
		LUC_VarToSend= 0x30+(((uchar)LUI_VarSend)>>4);
	OS_Lcd_Char(LUC_VarToSend);
	
	if ((((uchar)LUI_VarSend) & 0x0F) > 9)
		LUC_VarToSend= 0x37 +(((uchar)LUI_VarSend) & 0x0F);
	else
		LUC_VarToSend= 0x30+(((uchar)LUI_VarSend)  & 0x0F);					// envoi quartet poids faible
	OS_Lcd_Char(LUC_VarToSend);
	
}







////////////////////////////////////////////////////////////////////////
////                          OS_interruption.c                     ////
////                                                                ////
////  Programme pour la gestion des interruptions					////
////                 18F242 quartz 20 MHz ou 10Mhz *4 (PLL) = 40Mhz ////
////  Auteur: 	LG					     							////
////  Date:	 17 novembre 2003                                     	////
////                                                                ////
////////////////////////////////////////////////////////////////////////
////        (C) Copyright 2003 - LG				             		////
////								     							////
////////////////////////////////////////////////////////////////////////


/********************************************************
Fonction: OS_InterruptHigh
Utilisation: Fonction d'interruption de priorit haute
Date: 17/11/2003
Auteur: LG
********************************************************/
#pragma interrupt OS_InterruptHigh save=PROD
void OS_InterruptHigh(void)
{/* Dclaration de variable locales */ 

/* Dbut du corps de la fonction*/
	if (INTCONbits.TMR0IF)		
	{	INTCONbits.TMR0IF = 0; // mise  zro du flag pour le Timer 0
		// traitement des moteurs qui sont cals sur le timer 0
		switch (GUI_Timing20ms){
			case TIMING_20MS:	// on va lancer un crnaux pour 1ms
//				GST_BIT_SystemInfo.Moteur =0;	// traitement des interruptions moteur finies on ne peut pas changer la consigne
				if ( GUC_MoteurDroit != MOTEUR_DROIT_ARRET)
				{
					PORTCbits.RC2 =1;
					GUC_Avancement++;
				}
				if ( GUC_MoteurGauche != MOTEUR_GAUCHE_ARRET)
				{
					PORTCbits.RC1 = 1;
					GUC_Avancement++;
				}
//				WriteTimer0(0xFFFF - TIMING_1MS);	
				TMR0H = ((0xFFFF - TIMING_1MS)>>8);
				TMR0L = (0xFFFF - TIMING_1MS); // c'est  ce moment que c'est vraiement crit
				GUI_Timing20ms = TIMING_1MS;
				break;

			case TIMING_1MS:	// on a eu 1ms il reste donc 19ms max
				if (GUC_MoteurDroit == MOTEUR_DROIT_AVANT)
					PORTCbits.RC2 =0; //  mise  0 du crneaux pour le moteur droit
				if (GUC_MoteurGauche == MOTEUR_GAUCHE_ARRIERE)
					PORTCbits.RC1 =0; // mise  0 du crneaux pour le moteur gauche.
//				WriteTimer0(0xFFFF - TIMING_1MS);	// on repart pour 1ms
				TMR0H =((0xFFFF- TIMING_1MS)>>8);
				TMR0L =(0xFFFF- TIMING_1MS); // c'est  ce moment que c'est vraiement crit
				GUI_Timing20ms = TIMING_2MS;
				break;

			case TIMING_2MS:	// on dj eu 2ms donc il reste 18ms
//				WriteTimer0(0xFFFF - TIMING_18MS);	// on rajoute se qu'il faut pour arriver  20ms!
				PORTCbits.RC2 =0; //  mise  0 du crneaux pour le moteur droit
				PORTCbits.RC1 =0; // mise  0 du crneaux pour le moteur gauche.
				TMR0H =((0xFFFF- TIMING_18MS)>>8);
				TMR0L =(0xFFFF- TIMING_18MS); // c'est  ce moment que c'est vraiement crit
				GUI_Timing20ms = TIMING_20MS;	// indication pour la prochaine interruption pour savoir si on redmarre une squence
				GST_BIT_SystemInfo.Moteur =1;	// traitement des interruptions moteur finies on peut changer la consigne dans le programme main.
			default:	// on n'est pas sens arriver ici!
				PORTCbits.RC1=0; // on remet  0 aussi pour le cas prcdent!
				PORTCbits.RC2=0;
				break;
			}
	// return ; // on sort de la boucle
	}// fin du traitemeny interruption  Timer0
	
	// remise  0 du flag d'interruption du Timer1
	//PIR1bits.TMR1IF = 0;
	
//	GST_BIT_SystemInfo.InterruptionHigh = 1; // indication qu'il y a eu une interruption
}


#pragma code

/********************************************************
Fonction: OS_InterruptHigh
Utilisation: Fonction d'interruption de priorit basse
Date: 05/12/2003
Auteur: LG
********************************************************/
#pragma interruptlow OS_InterruptLow 
void OS_InterruptLow(void)
{/* Dclaration de variable locales */ 

/* Dbut du corps de la fonction*/
/*	if (INTCONbits.TMR0IF)		
	{	INTCONbits.TMR0IF = 0; // mise  zro du flag pour le Timer 0
		// traitement des moteurs qui sont cals sur le timer 0
		switch (GUI_Timing20ms){
			case TIMING_20MS:	// on va lancer un crnaux pour 1ms
				GST_BIT_SystemInfo.Moteur =0;	// traitement des interruptions moteur finies on ne peut pas changer la consigne
				if ( GUC_MoteurDroit != MOTEUR_DROIT_ARRET)
					PORTCbits.RC2 =1;
				if ( GUC_MoteurGauche != MOTEUR_GAUCHE_ARRET)
					PORTCbits.RC1 = 1;
				WriteTimer0(0xFFFF - TIMING_1MS);	
				GUI_Timing20ms = TIMING_1MS;
				break;

			case TIMING_1MS:	// on a eu 1ms il reste donc 19ms max
				if (GUC_MoteurDroit == MOTEUR_DROIT_AVANT)
					PORTCbits.RC2 =0; //  mise  0 du crneaux pour le moteur droit
				if (GUC_MoteurGauche == MOTEUR_GAUCHE_ARRIERE)
					PORTCbits.RC1 =0; // mise  0 du crneaux pour le moteur gauche.
				WriteTimer0(0xFFFF - TIMING_1MS);	// on repart pour 1ms
				GUI_Timing20ms = TIMING_2MS;
				break;

			case TIMING_2MS:	// on dj eu 2ms donc il reste 18ms
				WriteTimer0(0xFFFF - TIMING_18MS);	// on rajoute se qu'il faut pour arriver  20ms!
				GUI_Timing20ms = TIMING_20MS;	// indication pour la prochaine interruption pour savoir si on redmarre une squence
				GST_BIT_SystemInfo.Moteur =1;	// traitement des interruptions moteur finies on peut changer la consigne dans le programme main.
			default:	// on n'est pas sens arriver ici!
				PORTCbits.RC1=0; // on remet  0 aussi pour le cas prcdent!
				PORTCbits.RC2=0;
				break;
			}
	 return ; // on sort de la boucle
	}// fin du traitemeny interruption  Timer0
	// Test des interruptions sur le port B utilis par l'acclrometre
GST_BIT_SystemInfo.InterruptionLow = 1; // indication qu'il y a eu une interruption
*/
}





